Fri Nov 24 15:34:17 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Declare this to be version 0.4.1

Fri Nov 24 14:58:27 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix compile warnings when debug is off.

Fri Nov 24 14:20:01 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Turn TIMING_PATCH off in cvs.

Fri Nov 24 14:14:58 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add parameter check to network databases to ensure that supplied
	  timeouts are positive.

Fri Nov 24 13:54:00 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix problem with tcp connections: the timeout parameter wasn't
	  being passed to select() correctly, causing a timeout of zero,
	  resulting in only local connections working.

Fri Nov 24 10:11:05 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Btree base files now store things in variable-length fields.
	  The format number is also now used.

	* New function sys_read_all_bytes() to read an entire file into
	  a string.

Thu Nov 23 19:40:31 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added automatic detection of fdatasync, checking if -lrt is needed,
	  and reverting to fsync if not present.

Thu Nov 23 18:12:59 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add a cancel method to QuartzTableManager(), and ensure it is
	  called if any errors occur while modifying the quartz database -
	  this prevents partial modifications being applied.

	* QuartzTableManager::set_revision_number() and apply() now return
	  void - exceptions are thrown if errors occur.

	* QuartzBufferedTables now free the memory they're using as soon as
	  possible when writing changes to disk.

	* Added QuartzBufferedTable::write() method - when implemented, this
	  will write the changes so far to disk and free the memory used,
	  but not make a new revision: this is wanted for some backends where
	  no sort of the modifications is needed, so they don't need to be
	  held in memory.

Thu Nov 23 16:31:45 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Re-arranged Btree::basic_open slightly to make it easier to
	  expand the number of available revisions in the future.

Thu Nov 23 16:26:09 GMT 2000 Olly Betts

	* Remote backend timeout now applies to connect() attempt too.

Wed Nov 22 19:01:33 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Don't return incorrect doccount if informational entries haven't
	  yet been created in the quartz record database.

Wed Nov 22 18:53:33 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* A couple of missed bits of the previous change - we no longer need
	  to do an initialisation step to databases, and we no longer need
	  to subtract 2 from the item count in recordtable to get the doccount.

Wed Nov 22 18:44:01 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Remove QuartzRecord::initialise() - replace by assuming initial
	  values if the TOTLEN or NEXTDID tags aren't present.  Stops having
	  a wasted revision when a database is created.

Wed Nov 22 18:35:56 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Remove QuartzBufferedTable::get_tag() method - was only used to
	  check whether a tag was present, not to access the tag.  Replaced
	  with a have_tag() method.  This tidying up should help with making
	  smart pointers to point to a tag - no longer have to deal with
	  null pointers.

Wed Nov 22 18:28:36 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Turned the rest of the Btree API functions into Btree member
	  functions.

	* Added a bit of const to sys_write_* and get_[u]int4

Wed Nov 22 15:53:16 GMT 2000 Olly Betts

	* Removed OmPostListIterator::get_termfreq() and
	  OmPostListIterator::get_collection_freq() - you don't expect a
	  container iterator to provide a method to find the size of the
	  container, and the database provides similar methods to find this
	  information.

Wed Nov 22 14:59:11 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add configure option to enable or disable compilation of the
	  indexer library - defaults to enable: --enable-indexer

	* Move textfile_indexer and index_utils into testsuite - not part
	  of the proper indexer.

Wed Nov 22 13:13:20 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Store positionlists in quartz using difference between successive
	  positions, rather than the raw positions.

	* Update TODO: have written collection frequency tests, and have more
	  stuff to be doing.

Wed Nov 22 12:25:38 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add missing dependency, so that todo.html gets rebuilt when
	  todo.xml is changed.

Wed Nov 22 11:50:21 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add --prefix and --exec-prefix parameters to libomus-config script.

Wed Nov 22 11:03:57 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Don't build indextest if you don't have LIBXML

Tue Nov 21 17:49:15 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Btree_close() -> Btree::commit() + delete B.

Tue Nov 21 17:19:38 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Modified QuartzPostList::delete_entry() so that it updates the
	  counts, even though it doesn't actually delete the entry yet.

Tue Nov 21 15:35:47 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Made the testsuite more colourful.

Tue Nov 21 15:16:00 GMT 2000 Olly Betts

	* OmEnquire::Internal now a public class so it can be a friend to
	  OmQuery (gcc 2.95.2 incorrectly accepts it when private).

Tue Nov 21 14:29:46 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Removed a rogue semi-colon introduced with the RTLD_DEFAULT fix.

Tue Nov 21 14:16:21 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Made the Btree opening functions member functions (as before,
	  the Btree_* functions remain as wrappers).  They are not
	  called from the constructor because they need to signal a
	  failure without throwing an exception.

	* The next() and prev() cursor functions were renamed to
	  next_default() and prev_default() due to a namespace collision.

Tue Nov 21 10:58:13 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Implemented collection frequency stuff.  This involves:

	  - Added an OmDatabase::get_collection_freq() method.
	  - Added an OmPostListIterator::get_collection_freq() method.
	    (Also, added an OmPostListIterator::get_termfreq() method)
	  - Postlists and Databases have get_collection_freq() method.
	  - QuartzPostLists store the collection frequency at the beginning
	    of the list.
	  - Added tests to apitest and quartztest for reading collection
	    frequencies, both from a single database and from several
	    databases.

	  Collection frequencies will not work with SleepyCat, InMemory, or
	  Muscat 3.6 databases.

	* Also, make tests clear old databases at _start_ of their test run,
	  but not in the middle, so that all the old databases are present
	  for inspection but don't interfere with the new test run.

Tue Nov 21 11:46:24 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* testsuite.cc should work when RTLD_DEFAULT is not defined.

Mon Nov 20 19:00:26 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added new class Btree_base encapsulating the structure of the
	  Quartz base file.

	* sys_read_bytes() and sys_read_block() now share most of their
	  code.  Some of the sys_* made available in btree_util.h.

	* Btree_create now a wrapper around Btree::create().

Mon Nov 20 14:27:20 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix some warnings in net/socketclient.cc.  Remove an unneeded line
	  in libomus-config.nodep.in.

Mon Nov 20 14:22:40 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* postlist.h now declares class OmKey - was failing to declare before
	  use, causing a compiler error (but only with
	  --disable-pthread-support)

Mon Nov 20 14:20:20 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Remove a compiler warning in quartz_database.cc

Mon Nov 20 14:13:31 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Simple bugfix to ombatchenquire.cc so that it compiles when
	  --disable-pthread-support is specified.

Mon Nov 20 12:56:56 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Removed mentions of termids from Quartz.

Fri Nov 17 19:00:23 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Removed uneeded macro from quartz_types.h

Fri Nov 17 18:24:29 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Bcursor is now closer to a proper class.  Bcursor_* functions
	  are now just wrappers.  Implementation moved to bcursor.cc

	* Some of the macros, helper functions, and types from btree.cc
	  have moved into separate header files.

Fri Nov 17 16:43:50 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Declare this to be version 0.4.0

Fri Nov 17 16:26:52 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Annihilated a small memory leak.

	* Fixed a problem with checking enable_shared.

Fri Nov 17 16:12:42 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Remove tests to check for Berkeley DB 3.1 - we don't use Berkeley
	  DB 3.1.

	* Made quartz compile by default - it now passes the testsuite (well,
	  apart from a small memory leak, but what's a small memory leak
	  between friends?).

Fri Nov 17 15:49:20 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Change an OmUnimplementedError into an OmInvalidOperationError
	  in MSetPostList

Fri Nov 17 15:39:29 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fixes to check key length when searching for a key or adding an
	  item.  If a key which is too long is searched for, it simply
	  will not be found (but cursor operations will find first key
	  before it, as expected).  If an attempt is made to add a key
	  which is too long, an exception will be thrown.

Fri Nov 17 14:37:38 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed a problem with errors opening a database at a particular
	  revision throwing an exception.

Fri Nov 17 14:18:02 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix to Bcursor_find_key() so that it reads the tag correctly when
	  searching for a key which doesn't exist, but the previous item
	  is split into multiple chunks (tag used to come from only the
	  final chunk).

Fri Nov 17 12:29:54 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix bug with applying new empty revisions to empty DBs - blocks no
	  longer get used up by this process.

Fri Nov 17 11:09:56 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add test to quartz of applying new revision numbers multiple times
	  and checking the filesize of the DB file.

Thu Nov 16 19:27:20 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Working through btree.{h,cc}:

	  Fixed compilation warnings.

	  Fixed some logic around read()/write() functions.

	  Changed ints to Btree_errors in a few places and added
	  BTREE_ERROR_NONE value.

	  Added Btree_strerror for use with Btree_errors.

	  Fixed a few FIXMEs, and added some more.

	  Did lots of tweaking to error handling.

	  There are a few more occurrences to change.  In some cases things
	  can be made much cleaner when the code is objectified with
	  constructors and destructors.  Most of Btree_quit() moved
	  into Btree::~Btree().

Thu Nov 16 14:48:05 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added method str(std::string) to om_ostringstream, to set
	  the value of the internal string.

	* The testsuite now has a global om_ostringstream "tout", which
	  should be used by test functions when printing anything out.
	  Everything sent to the stream will be thrown out when the test
	  succeeds, or printed out if it fails.

	* Tests in api_db.cc modified to use tout.

Thu Nov 16 11:52:29 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added quartz_document.cc to CVS.

Wed Nov 15 18:14:10 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added QuartzDocument class, and implemented QuartzDatabase::
	  open_document().

	* Removed BerkeleyDB 3.1 bits from the Quartz Makefile.am

Wed Nov 15 14:52:19 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added stub operator new[]() and operator delete[]() to
	  testsuite.cc.  This has fixed the bizarre reported memory
	  leaks in indextest - presumably our operator delete() wasn't
	  being called for delete [] buf.

Wed Nov 15 14:11:21 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed the OMEXCEPT errors from indextest.  There's still a leak.

Tue Nov 14 19:28:18 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Moved omnodeconnection.h from indexer/indexgraph to include/om

	* Added new methods desc_from_file(), desc_from_string(), and
	  sort_desc() to OmIndexerBuilder interface, and get_node_info().

	* Fixed a few warnings in node source.

Tue Nov 14 19:26:28 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fixed bug with skip_to in quartz position lists - quartz now
	  passes all but 3 api tests.  Added a dummy test to quartz to
	  remind me to implement a few more tests of the quartz position
	  lists.

Tue Nov 14 17:32:06 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add hack to malloccheck.so to allow running of gdb with the malloc
	  checking.  To run gdb, set environment variable USE_GDB to gdb
	  command: eg, USE_GDB="../libtool gdb" ./run-apitest

Tue Nov 14 17:22:28 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added new debugging category for display of messages related to
	  introspection methods.  Should have debugging completely cluttered
	  with get_description() methods now.

Tue Nov 14 13:33:24 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Don't compile malloccheck if shared libraries are disabled.

Thu Nov  9 17:23:03 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added readonly implementation of posting lists.  Just need to add
	  writing for postlists, and plug it in to database, and quartz
	  should be functional.

Thu Nov  9 17:01:40 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed indextest on harvey.  The libxml wasn't using default
	  values for tag attributes (which may be related to the
	  lack of validation), so the test cases have the attributes
	  explicitly added.  Tidied things at the same time.

Wed Nov  8 19:29:01 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* TEST_EXCEPTION() now reports the location of the testcase, just
	  like all the other TEST* macros.

Wed Nov  8 19:25:46 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Position lists can now be written to - all quartz tests now pass.
	  (Quartz tests do not yet check postlist behaviour however -
	  postlists are to be implemented tomorrow.)

Wed Nov  8 18:13:54 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a couple more index tests.

Wed Nov  8 17:01:05 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added implementation of position lists to quartz - only lets
	  position lists be read as yet, no facilities for writing them.

Wed Nov  8 13:52:56 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Much work on quartz - it now passes all its tests except the one
	  using position lists (which aren't implemented yet), using the
	  Btree manager.  Work remains to be done on catching error
	  conditions, but the basic structure is now done.

Wed Nov  8 13:40:26 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Factored some common code out of most index tests.

Wed Nov 08 12:16:20 GMT 2000 Olly Betts

	* Switched back to MSetPostList (for now at least).

	* select() now checks for error conditions on sockets as well as
	  data available to read.

Tue Nov  7 18:22:16 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Removed unnecessary FIXME comments.

Tue Nov  7 17:51:47 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* General indexer cleanups and FIXME fixing.

	* OmIndexerData has new methods set_vector(), set_empty(),
	  eat_list(), and eat_element().  swap() has been made public.
	  eat_* and swap() allow more efficient manipulation of
	  indexer data when the original does not need to be preserved.
	  set_{int,double,string} have actually been implemented.

	* OmIndexerNode has new methods get_config_int(), get_config_double(),
	  get_config_vector() so the configuration parameters are more
	  useful.  Also added a set_output() variant for const OmIndexerData&,
	  for convenience.

	* OmConstantNode now supports int, double, and vector types as
	  well as string.

	* Implemented config_modified() for several nodes.

	* OmListConcatNode makes use of more efficient data shuffling.

	* OmStemmerNode modifies the list of words in-place rather than
	  building a new list.

Tue Nov  7 15:26:32 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Documented the rest of the indexer nodes.

Tue Nov  7 13:37:26 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* More node documentation comments.

Tue Nov  7 10:38:54 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed another unterminated comment.

Tue Nov  7 10:25:29 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed an unterminated comment in omflattenstringnode.cc

Mon Nov  6 19:01:43 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Various modifications to quartz.  Martin's library is now C++ in
	  name, slowly becoming that in style and organisation.  Quartz
	  now uses martin's library, and some of the tests even pass.

Mon Nov  6 18:59:33 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added documentation to about half of the indexer nodes.

Mon Nov 06 18:25:22 GMT 2000 Olly Betts

	* Backed out changes to allow remote streamed mset to listen to
	  min_weight and skip_to messages (change was a quick hack to see
	  if it helped, but it doesn't).

Mon Nov 06 16:32:08 GMT 2000 Olly Betts

	* Reinstated AssertEqDouble() - now does an epsilon test as
	  originally intended.

Mon Nov 06 13:31:00 GMT 2000 Olly Betts

	* Fixed handling of min weight changes with streamed msets.

Fri Nov  3 18:33:20 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added several extra checks to cursor behaviour in quartztest.

	* Split QuartzTableEntries::get_item_and_advance() into get_item()
	  and advance().

	* Change AssertEqDouble to AssertEq - it works usefully for lots of
	  types.

	* Implemented QuartzDiskTable cursor operations fully.
	  Implemented QuartzBuffTable cursors except for coping with
	  entries deleted in buffer but not on disk.

	* Typedefed contents of QuartzTableEntries, and added iterator methods.

	* quartztest tests of tables unlink old tables before running.

Fri Nov 03 17:29:05 GMT 2000 Olly Betts

	* Remote streamed mset now listens to min_weight and skip_to
	  messages.

Fri Nov  3 16:23:16 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* indexerquickstart again.  Added more, and removed redundant stuff
	  which is in quickstart.html

Fri Nov 03 16:08:20 GMT 2000 Olly Betts

	* Corrected '#endif' to '#else'.

Fri Nov 03 14:59:48 GMT 2000 Olly Betts

	* MergePostList now reads entries from each postlist in turn unless
	  USE_MSETPOSTLIST is defined.

Fri Nov 03 14:29:14 GMT 2000 Jon Fielder

	* Added 'TIMING_PATCH' for performance testing of distributed
	  searching.

Fri Nov  3 11:30:30 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add a little hack to malloc_wrapper.sh to allow tests in deeper
	  directories to find malloccheck.so.

Thu Nov  2 18:49:58 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* More stuff in indexerquickstart.html

Thu Nov  2 18:24:12 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add `extern "C"' to btree.h so that it will link with C++ code.

	* QuartzDiskTable now has set_entry() and apply() methods rather than
	  a single set_entries() method - this is more flexible and neatens
	  the code considerably.

	* Don't store btree pointers in AutoPtr's - they're not created by
	  new.

	* Implement remaining methods in QuartzDiskTable

	* Make quartztest compile by correcting syntax for using cursors.

	* Add a btree regression test to quartztest.

Wed Nov  1 18:59:28 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Corrected a couple of points in btree_api.txt

	* More work on quartz - implemented cursors, and some cursor operations.

Wed Nov  1 18:26:53 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Wrote more of the indexer quickstart document.

Wed Nov  1 13:00:33 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add header guards to btree.h - should fix includetest.

Tue Oct 31 18:23:57 GMT 2000 Olly Betts

	* Encoding of terms changed to a scheme which takes approximately
	  half the space.

Tue Oct 31 18:18:36 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* More work on the indexer quickstart document.

Tue Oct 31 18:10:49 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Begun changing implementation of QuartzTable to use btree stuff.
	  Currently doesn't compile.

	* Added quartztest that opening an unavailable revision of a valid
	  database doesn't throw an exception.

	* More updates / corrections to btree_api.txt documentation.

Tue Oct 31 16:25:14 GMT 2000 Olly Betts

	* Fixed a few warnings from gcc.

Tue Oct 31 16:12:46 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added OmMakePairNode, OmMakePairsNode, OmMakeRangeNode,
	  OmSelectItemsNode

	* OmRegexMatchNode uses empty strings rather than empty data
	  items for unmatched subexpressions.

	* Regex object keeps track of the pattern string

Tue Oct 31 16:12:12 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Remove argument of Btree_item_create().

	* Add several tests of quartz tables, prior to replacing their
	  implementation with Btree calls.

Tue Oct 31 14:36:08 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Remove a couple of statics which shouldn't have been there, causing
	  compiler warnings.

Tue Oct 31 14:34:19 GMT 2000 Olly Betts

	* Revised remote protocol to be somewhat less verbose.

Tue Oct 31 14:18:24 GMT 2000 Olly Betts

	* Improved output from test programs.

Tue Oct 31 13:12:15 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Removed QuartzRevisionNumber class - just use the revision number
	  as an integer.  Unnecessary layer of abstraction.

Tue Oct 31 11:05:46 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add Btree implementation to quartz directory.  Not yet used.

Mon Oct 30 19:05:23 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added OmKeylistAddNode and OmRegexMatchNode.

	* Some slightly more helpful exception messages

	* OmTermlistAddNode and OmPrefixNode support flat strings as
	  well as lists of strings

	* Better support for submatches in regexcommon

Mon Oct 30 17:37:33 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add a FIXME in irweight.cc

Mon Oct 30 17:35:17 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added test to quartz to check behaviour of cursor operations.
	  Test is fairly comprehensive - cursor operations don't yet work.

Mon Oct 30 16:13:09 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add entry to todo.

Mon Oct 30 14:20:46 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed a segfault when trying to use a non-existent node type,
	  and added a test for it.

Fri Oct 27 19:52:55 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* New indexer nodes: omnewkeylist, omnewtermlist, and omtermlistadd
	  for managing term and key lists.  ommakedoc for combining all
	  the parts of a document in the proper format.  omconstant for
	  outputting constant (string ATM) values.

	* Added OmIndexerData::get_description() and corresponding output
	  function.

	* Fixed OmIndexer's interpretation of the output document message.

	* Clarified some exception messages

Fri Oct 27 14:57:23 BST 2000 Olly Betts

	* OmEnquireInternal -> OmEnquire::Internal; OmQueryInternal ->
	  OmQuery::Internal.  More work than you'd think!

Fri Oct 27 13:54:13 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added OmMakeDocNode to combine data, terms, keys at the end
	  of an indexer

	* Fixed segfault in OmRegexFilterNode

Thu Oct 26 18:32:36 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Start of an indexer quickstart

Wed Oct 25 17:03:03 BST 2000 Olly Betts

	* RemotePostList is now filtered through a forming mset at the
	  remote end.  Min weight and skip_to messages from the client
	  currently ignored.

Wed Oct 25 13:00:39 BST 2000 Olly Betts

	* Factored out MultiMatch::get_collapse_key().

	* Matcher now exits early for boolean queries when
	  match_sort_forward is on (which it is by default).

Wed Oct 25 11:32:33 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed a bug in the indexer dataflow checking which complained
	  when there was no problem.

	* Enabled omlistconcat test, which was failing due to that bug.

Wed Oct 25 10:36:57 BST 2000 Olly Betts

	* Switched matcher back to using MSetPostList-s for now.

Tue Oct 24 18:57:58 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* OmIndexerData now uses vector::size_type instead of int in some
	  places dealing with vectors - gets rid of some compiler warnings.

	* The omfilereader node works better.

	* More tests in indextest, plus an extra text file for use with
	  the omfilereader tests.

Tue Oct 24 12:56:22 BST 2000 Olly Betts

	* {skip_to,next}_handling_prune functions added to neaten up
	  handling of prunes in the postlist tree.

	* matcher now has two stages - one to get the mset full of
	  candidates and another to continue the match with a full mset.

Sat Oct 21 07:54:53 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added quartzdesign.html document to docs/

Fri Oct 20 18:17:21 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* In quartz: store document lengths in termlists, store total
	  length in a field in the record table, and add methods to access
	  all these.  QuartzDatabase::get_avlength() now implemented.

Fri Oct 20 16:21:41 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* The xml warn function now prints to debug rather than stderr

	* Added more indexer tests

Fri Oct 20 15:14:47 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added autoconf/definedir.m4

Fri Oct 20 14:55:59 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added DATADIR define to find the arch-independent data, with
	  m4 macro AC_DEFINE_DIR.

	* Added omindexer.dtd to the distribution.

	* Indexer now finds the DTD by itself to use for verification,
	  either in DATADIR or by the OM_DTD_PATH environment variable.

	* Indexer tests no longer specify the DTD in the XML descriptions.

	* malloc_wrapper.sh sets OM_DTD_PATH.  Should probably be renamed
	  to run_test.sh or something.

Fri Oct 20 13:58:57 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fixed checks for document IDs being 0 or termnames being "" in
	  API.  Changed checks in Quartz for these conditions into Asserts.

Fri Oct 20 13:01:26 BST 2000 Olly Betts

	* Added `make ctags' rule.

Fri Oct 20 12:55:10 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fixed refcount problem with Quartz - references were being held
	  to the QuartzDatabase member of a QuartzWritableDatabase.
	  Restructured to tidy up and avoid this:  QuartzTermLists now hold
	  a refcount pointer to the appropriate database, and store a
	  pointer to the lexicon table to use directly if required.

Thu Oct 19 16:47:18 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a few indexer tests.

	* Made the START node's output be a wildcard type.

Thu Oct 19 16:03:01 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* quartz_lexicons allocate new term IDs (untested).

Thu Oct 19 13:00:52 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Implemented quartz_lexicon, except for allocation of new term IDs.
	  Close to working correctly, except for unexplained refcount problem
	  in testsuite.

Thu Oct 19 09:59:15 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added quartz_lexicon.{cc,h}.  Appropriate interface - not yet
	  implemented though.

Thu Oct 19 09:08:50 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* QuartzTermLists now implemented, and roughly tested.  Quartz test
	  currently fails because databases don't yet have get_termfreq()
	  implemented.

Wed Oct 18 16:19:42 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Error handler is now set in constructor of OmEnquire - this means
	  that errors during the constructor can be handled, and also helps
	  to ensure that handler is deleted after OmEnquire.

	* Error handler copes with (most) problems in
	  MergePostList::recalc_maxweight(), and in the event of an error it
	  can cope with, replaces the relevant postlist by an emptypostlist
	  instead of deleting it.

	* Renamed test multidb6 to multierrhandler1.  This test now passes.

	* omerror.h has the actual definitions of the errors split off into
	  separate file omerrortypes.h, for reuse elsewhere (eg,
	  net/omerr_string.c)

	* network errors handle new context field.  Modified encode_tname and
	  decode_tname so that a null term is not completely empty.  Modified
	  query parser to match new termname encoding.  Incremented protocol
	  version.

	* Added items to TODO.

Wed Oct 18 15:38:39 BST 2000 Olly Betts

	* New RemotePostList which streams postings across a network
	  connection.  Show give faster remote matches when the bandwidth
	  is good.

	* MSetPostList::get_max_weight() now returns the weight of the current
	  item once it starts being read - weights decrease down the mset, so
	  all no weight can be greater than the current one.

	* Reverted Richard's max_possible_item change as after discussion
	  we've decided it doesn't actually work correctly.

Wed Oct 18 14:17:21 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a debug class for indexer messages

	* Some changes to the indexer semantics.  Inputs from a given node
	  are all fetched at once, and some dataflow checking is done to
	  detect potential errors where data gets out of step.

	* Added a test that the above checking works to indextest.

	* Added new exception: OmDataFlowError, used in the indexer.

	* The START node gives slightly more helpful errors when misused.

	* Added the indexer DTD to data_DATA (and renamed it to omindexer.dtd
	  from test.dtd)

Tue Oct 17 18:44:43 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* API Change: add error handlers.  This involves: adding an
	  OmErrorHandler base class, which should be subclassed to make a
	  custom handler; and adding a OmEnquire::set_error_handler() method.
	  OmErrors also have a new flag

	  The error handler is used in the OmEnquire object, and any errors
	  produced by this object will be passed to the handler before being
	  thrown.  The handler is also used by the matcher (in fact, by
	  MergePostList), and errors in a merge postlist may be ignored
	  and coped with as well as possible if the error handler decides
	  not to propagate the error.

	* Added a "context" member to OmErrors - this is set to a null string
	  at the moment, but will be used to store the context which an error
	  occurred in at a later date - for example, the identity of the
	  database in which a remote error occurred.

	* Added a parameter to InMemory databases which causes any postlists
	  to throw a database corrupt error when next is called.  Also added a
	  parameter to progserver to cause this parameter to be specified for
	  the database being opened.  This allows testing of the error handler
	  code.

Tue Oct 17 15:53:47 BST 2000 Olly Betts

	* net/progserver.cc: Removed `#include "localmatch.h"' - missed this
	  file in earlier checkin.

Tue Oct 17 12:58:48 BST 2000 Olly Betts

	* If OM_DEBUG_FILE contains %%, substitute the process id.

Tue Oct 17 12:56:56 BST 2000 Olly Betts

	* tests/.cvsignore: added indextest.

Tue Oct 17 12:40:07 BST 2000 Olly Betts

	* localmatch.h: moved from common to matcher.

Mon Oct 16 19:09:22 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added OM_MAX_POSS_DOCID macro to om/om_types.h, to represent the
	  maxiumum value that a document ID may take (in a particular
	  compilation of the library.)  Use this in multimatch.cc for the
	  document ID in max_possible_item.

Mon Oct 16 18:59:35 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* In multimatch.cc, replace w_max by max_possible_item, so that
	  early termination comparison takes document ID into account. This
	  may fix the problem with boolean queries not terminating early.

Mon Oct 16 16:42:17 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added dummy implementation of get_next_entry() in quartz_table.cc
	  so that builds may proceed.

Mon Oct 16 15:46:31 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added cursor operations to QuartzTable, so that we can move through
	  items in order.

Mon Oct 16 14:24:01 BST 2000 Olly Betts

	* OmSocketLineBuf::do_readline: fixed core dump on time out.

Mon Oct 16 13:30:34 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add quartz_termlist.cc to CVS and uncommented it in the makefile.

Mon Oct 16 12:21:41 BST 2000 Olly Betts

	* indexer/indexgraph/indexerxml.cc: Quick bodge fix for XML_DTD_PATH
	  not being defined - needs the correct fix from Chris.

Fri Oct 13 16:03:09 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed some leaks in the indexer system

Fri Oct 13 13:47:32 BST 2000 Olly Betts

	* backends/quartz/Makefile.am: Commented out quartz_termlist.cc as
	  it's not yet in cvs and is blocking nightly snapshots.

Thu Oct 12 16:55:42 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Convert statssource pointer in LocalSubMatch into an AutoPtr, to
	  fix memory leak bug (exhibited if an exception is thrown in
	  constructor).

Thu Oct 12 16:49:04 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Changed the interface for creating indexer nodes.
	  Inputs are all fetched at once by request_inputs(), which must
	  be called before any call to get_input_*.  It can be called
	  more than once.

	* The nodes now all use request_inputs()

Thu Oct 12 16:37:42 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* DatabaseBuilder::create() now returns a RefCntPtr, rather than a
	  bare pointer, to prevent accidents involving not referring to
	  a database by refcnt, making a {post,position,term}list, and then
	  accidentally deleting the termlist when that list is deleted (and
	  decrements the refcnt on the database back to 0).

	* Added an assert to refcnt, to ensure that a refcnt pointer isn't
	  made from `this', when this object isn't yet held by a reference
	  counted pointer.

	* Added a termlist to Quartz.  No implementation yet.

	* Removed some old debugging code from Quartz.

Thu Oct 12 14:45:03 BST 2000 Olly Betts

	* Moved common/networkmatch.h into match/

Thu Oct 12 14:28:21 BST 2000 Olly Betts

	* NetClient: Merged set_rset() into set_query().

Thu Oct 12 12:55:53 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Attributes are now readable.  Partially tested.  Bug fixed in
	  temporary table implementation for quartz.

Wed Oct 11 18:55:39 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added Attributes (ie, Keys) to quartz.  Can write them, and has
	  structure in place for reading them.  Reading not yet written,
	  tests not yet written.

Wed Oct 11 18:24:16 BST 2000 Olly Betts

	* Profiling now seems to be working.

Wed Oct 11 17:58:34 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added OmVectorSplitNode (splits a vector into several messages)

	* Gave AutoPtr an extra assignment operator to avoid extra
	  variables

	* Nodes now handle empty messages as an "end of data" better.

Wed Oct 11 17:40:36 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Wildcard types which only appear as outputs now work.

Wed Oct 11 17:37:57 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added method OmIndexerNode::set_empty_output(), useful as
	  a shorthand for set_output("foo",
	  OmIndexerMessage(new OmIndexerData()))

Wed Oct 11 17:35:49 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* New method is_empty() for OmIndexerData to easily check for
	  empty messages.

Wed Oct 11 17:27:49 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Parameter strings can be kept inside <param></param> instead of
	  the <param value=""> attribute.  The former doesn't mangle
	  whitespace.

Wed Oct 11 11:17:52 BST 2000 Olly Betts

	* Added profiling variant of DEBUGCALL() and DEBUGCALL_STATIC(),
	  turned on with --enable-debug=profile switch to configure.
	  Reported information needs more work.

Tue Oct 10 17:03:07 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix bug in temporary implementation of quartz_table - now stores
	  records with weird characters correctly.

Tue Oct 10 14:41:49 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix documentation comment in database.h

Tue Oct 10 14:14:40 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added quartz_block_size parameter - and pass it down to the
	  constructor of a QuartzDiskTable, ready for use when the Btree
	  manager is added.

	* Removed old quartz_{diffs,modifications}.{cc,h} files - obselete.

Tue Oct 10 12:14:20 BST 2000 Olly Betts

	* Documents should now fetch in parallel pipelines with the remote
	  backend.

Mon Oct  9 18:13:14 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Quartz now stores general database information in record database.
	  Very close to allocating new document ID's correctly.

	* Quartz database initialisation code is separated out of table
	  manager.

	* {un,}pack_uint32 functions changed to {un,}pack_uint templates -
	  should work on different data type sizes.  Work towards using
	  whatever datatype sizes are handy, rather than relying on any
	  particular size.

Mon Oct 09 18:09:05 BST 2000 Olly Betts

	* StatsSource::set_gatherer() merged into ctor;
	  my_collection_size_is() and my_average_length_is() merged as
	  take_my_stats().

Mon Oct  9 17:19:31 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added OmFileReaderNode

Mon Oct 09 16:19:43 BST 2000 Olly Betts

	* Cleaned up members of SubMatch and subclasses.

	* Merged NetClient::set_query() and set_options().

Mon Oct 09 15:27:59 BST 2000 Olly Betts

	* Implemented OmEnquire::get_docs() - currently just fetches them
	  sequentially.

	* Removed unused max_weight element from OmQueryInternal

Mon Oct  9 14:39:34 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Part-implemented add_document and delete_document methods in
	  quartz - document data is now added, stored and deleted.  Terms are
	  not dealt with, though.

Mon Oct 09 14:22:04 BST 2000 Olly Betts

	* Added SubMatch::start_match() so we can set remote matchers going
	  in parallel.

	* Added PostList::get_collapse_key() so we don't need to refetch keys
	  for hits from an MSetPostList.

Mon Oct 09 13:54:13 BST 2000 Olly Betts

	* IRWeight::clone() -> IRWeight::create(const OmSettings & opts)

Fri Oct  6 18:43:41 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added QuartzWritableDatabase, which inherits from QuartzDatabase.
	  We now open one of these instead of passing readonly=true.

Fri Oct  6 17:40:38 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added indexer headers to <om/om.h>

Fri Oct  6 17:19:07 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Implemented the new OmIndexer::get_output()

Fri Oct  6 13:15:45 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* QuartzBufferedTable::get_or_make_tag() now never returns a null
	  pointer, as advertised.  Fixes broken test.

Fri Oct  6 12:02:53 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add autoptr cleanup item to todo.

Thu Oct  5 18:28:48 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Renamed OmIndexer::get_output to get_raw_output and added new
	  get_output returning an OmDocumentContents (not yet implemented)

	* Removed omindexer.h~, which managed to be added to CVS

Thu Oct  5 18:24:02 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added test of QuartzBufferedTable (fails).

Thu Oct  5 18:01:27 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Corrected includes of autoptr.h in quartz files.

Thu Oct  5 17:51:01 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Made QuartzTable into a base class for QuartzDiskTable and
	  QuartzBufferedTable.

	* Made QuartzTableManager into a base class for QuartzDiskTableManager
	  and QuartzBufferedTableManager.

	* Removed QuartzModifications object.  We now use
	  QuartzBufferedTables to hold changes before committing instead.

	* QuartzDatabase has a QuartzTableManager object, which is actually
	  a QuartzBufferedTableManager if the database is writable.
	  Separate pointer held to access the manager as a buffered manager
	  in this case.  This means that updates to the database will
	  immediately be accessible from the same quartz database object
	  (so searches while indexing will search across all the unflushed
	  changes too).

Thu Oct 05 16:51:09 BST 2000 Olly Betts

	* get_weight() moved into LeafPostList instead of subclasses and now
	  only fetches document length if it needs it.

	* irweight.cc: added missing licence.

	* IRWeight: now possible to register user weight objects (not yet
	  externally visible).

Thu Oct  5 16:43:59 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added omindexer.cc

Thu Oct  5 15:57:30 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed some #includes.

Thu Oct  5 14:32:59 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Split indexer interface into several header files in include/om.

	* Hid the internal details in Internal objects.

	* Moved autoptr.h into include/om as AutoPtr is in the indexing
	  interface.

Thu Oct 05 13:30:49 BST 2000 Olly Betts

	* OmPostListIterator: added get_doclength() and get_wdf() methods;
	  fixed reversed conditional that stopped OmPostListIterator-s from
	  working and added regression test.

	* delve: extra info can be output for postlists and termlists (-v);
	  can output one list per line or one item per line (-1); can take
	  several database(s).

Wed Oct 04 18:20:12 BST 2000 Olly Betts

	* Merged branch_newmatcher back into HEAD - branch ChangeLog
	  entries were:

===============================================================================

Wed Oct 04 17:24:26 BST 2000 Olly Betts

	* Added ExtraWeightPostList - weights from MSetPostList no longer get
	  extra weight applied twice.

	* SingleMatch no longer used so removed; SubMatch moved to match.h;
	  SubMatch::mk_weight() moved to LocalSubMatch().

Wed Oct 04 15:36:09 BST 2000 Olly Betts

	* Removed references to multi backend since it no longer exists.

Wed Oct 04 14:53:28 BST 2000 Olly Betts

	* Removed PostList::set_matcher().

Wed Oct 04 13:15:04 BST 2000 Olly Betts

	* Eliminated internal friends from external headers.

	* Fixed two more compiler warnings.

Wed Oct 04 11:43:19 BST 2000 Olly Betts

	* stats.h: Removed unneeded bodge.

	* Fixed two compiler warnings.

Tue Oct 03 18:32:35 BST 2000 Olly Betts

	* Merged LocalMatch into MultiMatch.

Tue Oct 03 17:04:17 BST 2000 Olly Betts

	* Now passes all tests.

Mon Oct 02 18:00:20 BST 2000 Olly Betts

	* Cleaned up a bit.

Mon Oct 02 17:28:53 BST 2000 Olly Betts

	* LocalMatch: Split off postlist tree generation into LocalSubMatch
	  (temporary name).  LocalMatch now just takes a single PostList and
	  forms an MSet from it.  Remote versions not yet implemented.

Thu Sep 28 12:19:25 BST 2000 Olly Betts

	* Major overhaul of matcher including addition of MergePostList and
	  MSetPostList.

	* Use OmDatabase instead of converting it into a MultiDatabase.

	* OmDatabase new methods: get_doccount(), get_avlength(),
	  get_termfreq(), get_doclength(), term_exists().

	* Currently MultiMatch / LocalMatch / NetworkMatch interface is
	  highly bodged.

===============================================================================

Tue Oct  3 18:14:51 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Changed QuartzModifiedTable to QuartzBufferedTable.

	* Moved QuartzDbTag and QuartzDbKey to quartz_table_entries.h, to
	  make include dependencies possible.  These should probably have a
	  file to themselves.

Tue Oct  3 14:28:48 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* QuartzDbTable becomes QuartzDiskTable, which inherits from
	  QuartzTable, and is a sibling of QuartzModifiedTable, which will
	  manage a modified table.

Tue Oct  3 13:56:23 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a topological sort of the input nodes before building the
	  graph, so the graph description no longer needs the nodes in
	  the right order.

Tue Oct  3 12:20:45 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Quartz tables and table managers are no longer reference counted -
	  one instance is held in the database class, and references will be
	  kept to that class.  Tables are now members of table manager class,
	  not just pointers held in that class.

Tue Oct  3 11:49:10 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Reorganise classes in Quartz, in preparation for changing Diffs
	  objects into modified table objects.

Mon Oct  2 19:36:21 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Rename settings parameter quartz_modification_log to quartz_logfile.

	* Don't increment revision number when applying null modifications.

	* Added test for adding a document and reading it out again.
	  (Currently fails with an unimplemented error.)

Mon Oct  2 18:09:34 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Overhauled the indexer graph type-checker.  Types which start
	  with "*" are now wildcard types, replacing the "ANY" type, and
	  providing more type safety than before.

Mon Oct  2 17:08:44 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* operator delete now prints a slightly helpful message before
	  aborting for a bad delete.

Mon Oct  2 16:21:16 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Improved messages to quartz log - can now make log entries when
	  opened readonly, if requested.

	* quartzopen1 now checks behaviour of flush(), and time at which
	  documents get written to database.  (Currently fails).

Mon Oct  2 14:27:00 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added utilities to pack and unpack integers to quartz_utils.h

Fri Sep 29 18:29:58 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Split XML-specific code into a separate file and cleaned up
	  the Makefile

	* Cleaned up the graph-building code (see above!)

	* Should now cope with comments anywhere in the XML file.

	* Can now build an indexer from an in-memory structure without
	  needing an XML description (fall-out from first item)

Fri Sep 29 13:38:10 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Workaround for a bad interaction between <rxposix.h> and some C++
	  header files like <map>

Fri Sep 29 11:40:04 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added omregexfilternode

Fri Sep 29 10:35:10 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Removed testnodes.h, which is obsolete and broke includetest.

Thu Sep 28 19:12:00 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add files containing generic utilities needed for quartz.

Thu Sep 28 18:19:17 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Removed some debugging code which doesn't work with some versions
	  of libxml anyway.

Thu Sep 28 17:55:30 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* regexcommon.h now has a guard for includetest

	* OmIndexerData no longer has a name element.

	* Added regex split node, translate node, and flatten-to-string node

	* Comments in the XML file don't confuse the graph builder as much
	  (more wrapping needs to be done here.)

Thu Sep 28 15:52:03 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fixed a silly memory leak in QuartzDbEntries.

Wed Sep 27 19:30:34 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Almost added ability to add an empty document to a quartz database
	  (yay(!)).  Added test for this, too.

Wed Sep 27 19:04:10 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a regex replace node.

Wed Sep 27 17:12:13 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed bug in timeout code

Wed Sep 27 13:26:47 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fixed bug in database.cc - only implicit sessions get implicitly
	  ended.

	* Implemented quartztest which opens a new database and adds an empty
	  document to it.

Wed Sep 27 11:52:09 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Compatibility tweak for older libxml

Tue Sep 26 18:17:38 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added dummy implementation of quartz tables, storing stuff in
	  files and reading it all into memory, pretending its in a tree
	  structure.

Tue Sep 26 18:17:11 BST 2000 Olly Betts

	* Removed superfluous MergePostList:: qualification.

Tue Sep 26 17:12:44 BST 2000 Olly Betts

	* OmTermListIterator: operator* now const; added get_wdf() and
	  get_termfreq() methods.

Tue Sep 26 13:30:42 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Remove a comment referring to auto_ptr

Tue Sep 26 13:28:13 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added retries and suchlike for opening quartz databases.  Tables
	  are now not opened by QuartzDbTable constructor - separate open
	  method.  Allows reopening, and a return value.

Tue Sep 26 12:40:31 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* omstopword node now properly configurable.

	* Improved handling of default properties

Tue Sep 26 10:12:23 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added omstopword node

Mon Sep 25 18:00:01 BST 2000 Olly Betts

	* MergePostList: now working - just need to sort out how it works
	  with the remote backend.

Mon Sep 25 15:36:17 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added omprefixnode

Mon Sep 25 15:11:41 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added omsplitternode and omlistconcatnode

Mon Sep 25 12:05:59 BST 2000 Olly Betts

	* Updated a couple of .cvsignore files.

Sun Sep 24 13:53:03 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added node_reg.h and register_core.h to Makefile.am

Sat Sep 23 16:17:10 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Passed srcdir into make_register.pl

Fri Sep 22 18:24:00 BST 2000 Olly Betts

	* mergepostlist.{cc,h}: started to rework matcher in earnest.

Fri Sep 22 18:19:13 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Now have a scheme for registering all the core indexer nodes
	  semi-automatically.

Fri Sep 22 14:59:20 BST 2000 Olly Betts

	* Tiny tweak to threadtest.

Fri Sep 22 14:44:06 BST 2000 Olly Betts

	* Fixed typo in DEBUGLINE() in localmatch.cc.

Fri Sep 22 13:26:54 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Enable malloc checking to be turned off by setting OM_NO_MALLOCCHECK

Fri Sep 22 12:20:38 BST 2000 Olly Betts

	* Renamed PostList::intro_term_description() to get_description()
	  for consistency with other classes.

Fri Sep 22 10:41:08 BST 2000 Olly Betts

	* Updated docs in irweight.h; tweaked multimatch.cc.

Thu Sep 21 18:56:23 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added more frobs to quartz: adding stuff to test revision number
	  semantics, and the usage of revision numbers.

Thu Sep 21 18:33:16 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added OmStemmerNode

Thu Sep 21 17:08:35 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix typo in tests/Makefile.am

Thu Sep 21 16:25:21 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Remove unwanted set_entries() method from QuartzDbTable - must now
	  specify new revision explicitly.  Updated testsuite accordingly.

Thu Sep 21 15:53:30 BST 2000 Olly Betts

	* Very minor changes to LocalMatch.

Thu Sep 21 15:38:05 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* More robust table opening for Quartz, and fixed testsuite.

Thu Sep 21 15:06:55 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Renamed Record to OmIndexerData and Message to OmIndexerMessage.

Thu Sep 21 13:05:58 BST 2000 Olly Betts

	* Removed unused variable `weights' from LocalMatch class.

Thu Sep 21 13:00:08 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* A fix for building on Solaris with gcc.

Thu Sep 21 12:58:18 BST 2000 Olly Betts

	* LocalMatch again.  Now that mopts is stored, we don't need to read
	  out most of the contents until we use them.

Thu Sep 21 11:37:39 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Make dist will now fail if Perl XML parser is not available - this
	  means that TODO's in the distribution should always be present and
	  up-to-date.

Thu Sep 21 11:16:22 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Various work making distclean remove all the files it should.  Still
	  leaves Makefiles in directories optionally configured off there,
	  automake bug perhaps?

Thu Sep 21 11:08:21 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Some tweaks to AutoPtr.

Wed Sep 20 19:07:30 BST 2000 Olly Betts

	* More LocalMatch work.

Wed Sep 20 18:57:55 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Make quartztest compile again.  (Though it fails)

Wed Sep 20 18:56:26 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* docs/Makefile.am, only build apidocs when making a dist, leave full
	  documentation for a local install.

Wed Sep 20 18:26:33 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Updated Quartz to use AutoPtr

Wed Sep 20 17:52:06 BST 2000 Olly Betts

	* More work on LocalMatch.

Wed Sep 20 17:49:23 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Updated NEWS

Wed Sep 20 16:48:20 BST 2000 Olly Betts

	* genacinclude.sh now lives in autoconf subdirectory.  List of .m4
	  files is now in buildall and autoconf/Makefile.am.

	* Started to tease apart LocalMatch - created SubMatch class to hold
	  Database and associated StatsSource.

Wed Sep 20 16:04:21 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Declare this to be version 0.3.1

Wed Sep 20 16:03:51 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Set up a DIST_SUBDIRS in backends/Makefile.am to ensure that
	  everything that should goes into a distribution.

Wed Sep 20 15:56:40 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* More fettling to Quartz - databases now have logic to ensure that
	  correct revisions get opened, and that recovery gets performed
	  if needed.  Tables can now return the currently opened revision
	  number and the latest available.  A log object is always created,
	  but throws away messages if readonly or no path specified.

Wed Sep 20 15:48:22 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Changed std::auto_ptr to AutoPtr everywhere except Quartz

Wed Sep 20 14:27:55 BST 2000 Olly Betts

	* IRDatabase renamed to just plain ol' Database.

Wed Sep 20 13:31:31 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added untested AutoPtr template (auto_ptr clone)

Wed Sep 20 13:11:30 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* malloc_wrapper.sh now passes parameters in

Wed Sep 20 13:02:22 BST 2000 Olly Betts

	* *PostList: Put back in Assert-s re at_end() not being valid before
	  next() or skip_to().

	* OmPositionListIterator: postincrement and skip_to now return void.

	* Added DEBUGAPICALL to OmDocumentTerm, OmDocumentContents,
	  OmSettings, OmPositionListIterator, OmTermListIterator.

	* Some work on getting Java auto-translation of apitest to work
	  again [actually checked in with previous changes].

Wed Sep 20 11:53:16 BST 2000 Olly Betts

	* Disabled special casing of postlists with termfreq == 0 when
	  building AND and OR trees.

	* Removed "get_maxweight()" and "recalc_maxweight()" implementations
	  from in EmptyPostList.

Wed Sep 20 10:36:26 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added malloc-wrapper.sh to the distribution.

Tue Sep 19 20:47:21 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Various modifications to Quartz.  Work towards making sure that
	  consistent revisions get opened, and that recovery is performed
	  when needed.

Tue Sep 19 19:13:02 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added OmNeedRecoveryError, to signal that a database needs a
	  recovery step to be performed.

	* Use $(LN_S) instead of ln -s in test/Makefile.am

Tue Sep 19 18:42:51 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Implement get_maxweight() and recalc_maxweight() in EmptyPostList
	  so that they don't attempt to use an invalid IRWeight object.
	  This fixes an assertion error if a list of terms which are not
	  in the database are combined in a query.

Tue Sep 19 15:55:34 BST 2000 Olly Betts

	* api_db.cc: Added query() helper functions

	* Added rsetmultidb3 to demonstrate assertion failiure in stats.h.

Tue Sep 19 15:50:26 BST 2000 Olly Betts

	* testsuite.cc: output newline after skipped test.

Tue Sep 19 15:33:24 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Now run apitest and internaltest with malloccheck if possible

Tue Sep 19 13:42:57 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed a memory leak in the Sleepycat backend.

Tue Sep 19 13:16:29 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* malloc tracking now copes with free(0).

	* Added OM_MALLOC_TRAP[_COUNT], similar to OM_NEW_TRAP[_COUNT].

	* Moved an Assertion in OmStem to somewhere more useful.

	* Fixed a memory leak in the French stemmer

Tue Sep 19 12:40:21 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add CME_FIND_HSTRERROR to acinclude.m4, by adding it to lists in
	  buildall and configure.in.

Tue Sep 19 12:11:58 BST 2000 Olly Betts

	* More work on tests.

Tue Sep 19 10:50:43 BST 2000 Olly Betts

	* More tests in apitest and includetest changed to use TEST_* macros.

Tue Sep 19 10:14:32 BST 2000 Olly Betts

	* Include genacinclude.sh in the distribution from the correct
	  directory.

Mon Sep 18 19:13:03 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Various work on Quartz - logfiles, putting general structure in
	  place, etc.

Mon Sep 18 19:10:23 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Slightly more accurate malloc/realloc implementation

Mon Sep 18 18:35:32 BST 2000 Olly Betts

	* Many tests in apitest changed to use TEST_* macros.

Mon Sep 18 18:23:50 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Can now add checking for memory leaks in testsuite via
	  LD_PRELOAD of malloccheck.so.  Seems to have a few problems
	  at the moment, though.

	* Added a test for the malloc tracking to internaltest.

Mon Sep 18 17:38:38 BST 2000 Olly Betts

	* All api tests now have a number suffix.

	* apitest_parser.pm cope with tests being declared "static".

Mon Sep 18 17:19:32 BST 2000 Olly Betts

	* Efficiency tweak to max_or_terms comparator - don't call
	  get_maxweight() if get_termfreq() is zero.

	* More minor rearrangments in preparation for merging LocalMatch and
	  MultiMatch.

Mon Sep 18 15:43:46 BST 2000 Olly Betts

	* A testsuite programs asked to run test "foo" will now run tests
	  "foo1", "foo2", ... if they exist.

Mon Sep 18 14:36:13 BST 2000 Olly Betts

	* Implemented API side of OmDatabase::positionlist_{begin,end} -
	  still needs support in backends.

Mon Sep 18 14:03:58 BST 2000 Olly Betts

	* Sorted out wrinkles with geacinclude.sh.

Mon Sep 18 13:02:36 BST 2000 Olly Betts

	* Added tests for skip_to on {Post,Term}ListIterator.

Mon Sep 18 12:59:39 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Keep a count of the skipped tests.

Mon Sep 18 12:31:05 BST 2000 Olly Betts

	* acinclude.m4 generation moved from buildall to a separate script
	  so that the Makefile can regenerate acinclude.m4 if necessary.

	* Use AC_CONFIG_AUX_DIR to reduce the clutter in the top level
	  directory.

Mon Sep 18 12:26:48 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Tests in the testsuite can now be skipped, and avoid being
	  counted as either a pass or a fail.

	* Leak detection code partly separated out.

Mon Sep 18 11:55:53 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* malloccheck now includes a naive memory allocation function to
	  use before malloc() and friends are found.  This removes the
	  gross dependency on glibc2 internals.

Mon Sep 18 10:57:16 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added malloccheck.c to the distribution.

Fri Sep 15 19:02:48 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added an LD_PRELOADable library to do some malloc() etc checking.
	  (Currently doesn't yet do leak checking, but does the accounting.)
	  May not work on non-glibc2 systems.

	* Simplified omerr_tostring so that it uses OmError::get_type().

Fri Sep 15 18:53:31 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix minor bug in newly altered weighting formula, and update tests
	  to expect new values.

Fri Sep 15 18:14:37 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Allow users to set the parameters used in the BM25 and traditional
	  weighting schemes.  Documented, but not tested.

Fri Sep 15 15:02:49 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Moved todo.xml to docs/

	* TODO is now generated from a rule in the root directory

	* TODO and docs/todo.html not generated if XML::Parser isn't
	  installed.

Fri Sep 15 13:26:16 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added an AC_MSG_WARN if validation is not supported

Fri Sep 15 12:59:17 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Hopefully fixed problems with older libxml not supporting
	  validation.

Fri Sep 15 12:01:34 BST 2000 Olly Betts

	* TODO and todo.html now generated from master todo.xml.

Fri Sep 15 09:07:04 BST 2000 Olly Betts

	* HTML TODO list coloured by priority.

Thu Sep 14 19:46:44 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add some tests for QuartzDbEntries object.  Need more.

	* Changed QuartzDbTable so that its methods merely Assert that keys
	  have non-zero length, rather than throwing exceptions.  This
	  condition should never arise.

Thu Sep 14 18:38:46 BST 2000 Olly Betts

	* Overhauled DEBUGCALL macros - now you can just use RETURN(...)
	  instead of return(...) in a method and the return value is dealt
	  with automatically.

Thu Sep 14 18:15:29 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added new exception OmInvalidDataError for bad data which
	  isn't really an API misuse.

	* Cleaned up the use of silly exceptions in the indexer code.

	* Indexer graph checks the XML source for validity.

	* Modified the DTD to allow list parameters as well as string.

Thu Sep 14 17:33:05 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Completed implementation of QuartzDbEntries.

Thu Sep 14 17:20:41 BST 2000 Olly Betts

	* Fixed some compiler warnings in stemmer code.

Thu Sep 14 17:09:53 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Rename QuartzDbBlocks to QuartzDbEntries and finish specifying the
	  interface.  Implementation is incomplete, but compiles.

	  This also removes the duplicate definition which was causing
	  includetest to fail.

	* QuartzDbDiffs now has a non-virtual apply() method - implementation
	  will be identical for all subclasses.

Thu Sep 14 15:06:24 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix the problem with max_or_terms and termfreqs of 0.  Test
	  maxorterms4 now passes.

Thu Sep 14 15:03:40 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add a test for doing max_or_terms when one of the query terms is
	  not in the database.

Wed Sep 13 19:07:11 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Small typo in DbTermList::get_termfreq() corrected.  Now works
	  correctly - multiexpand1 passes. :)

Wed Sep 13 18:49:27 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix apitest so that the OmBatchEnquire::query_desc structure gets
	  created.

	* Attempt to fix DbTermLists handling of term frequencies: if the
	  termfreq was not present it was being mishandled.  However,
	  multiexpand1 still fails. :(

Wed Sep 13 18:05:19 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* QuartzDbTable now has a get_entry_count() method to ... count its
	  entries.  Also added a test for this.

Wed Sep 13 18:02:38 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* includetest.o now compiled with LIBXML_CFLAGS

Wed Sep 13 17:52:12 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* QuartzDbTables now implemented (as maps) and pass testsuite.

Wed Sep 13 17:34:03 BST 2000 Olly Betts

	* test programs can now take a list of tests to on the command line.

Wed Sep 13 15:34:18 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* OmBatchEnquire::query_desc now initialised its elements to values
	  which will avoid random segfaults in unwary user code.

Wed Sep 13 15:33:35 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Some changes to Python (and general SWIG) bindings to support
	  new OmDatabase and OmSettings.  There's a bug in there somewhere
	  though.

Wed Sep 13 15:23:26 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added the native part of the OmSettings Java wrappers.  (Oops!)

Wed Sep 13 15:13:53 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* OmPostListIterator::get_description() doesn't dump core when
	  internal is 0.

Wed Sep 13 14:42:03 BST 2000 Olly Betts

	* Updated TODO.

	* Fettled localmatch.cc in preparation for major rework.

Wed Sep 13 14:28:52 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fix reversed test bug in OmIndexer::set_node_config()

Wed Sep 13 13:14:23 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add lots of tests of the QuartzDbTables.  Currently these fail due
	  to a missing implementation.  In the short term they'll be pointing
	  at a map, but will prove useful when Martin's stuff replaces that.

Wed Sep 13 12:31:25 BST 2000 Olly Betts

	* OmRefCnt* -> RefCnt*; omrefcnt.h -> refcnt.h; OmSettingsData ->
	  SettingsData.

Wed Sep 13 11:28:18 BST 2000 Olly Betts

	* Use libtool's -export-symbols-regex switch to cut down on junk
	  symbols in library.  Doesn't really work as we'd hope as we get to
	  play with the mangled symbols.

Wed Sep 13 10:08:25 BST 2000 Olly Betts

	* Updated TODO.

	* OmDatabase::postlist_begin/end now throw OmInvalidArgumentError
	  if passed a zero length termname.

	* Fixed up OmPostListIterator so copy and assignment work;  end now
	  uses NULL internal rather than an EmptyPostList.

	* Om*Iterator::skip_to now returns void.

	* Added postlist[123] tests for OmPostListIterator.

	* Now run localdb tests on da and db backends (multiexpand1 currently
	  fails for db).

Wed Sep 13 00:47:55 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Quartz:  database tables now have a class to store revision numbers
	  in, which ensures that they are only compared for equality and
	  thus avoids issues with eventual wrap-around.  Testsuite also now
	  tests this class, and passes the test.

Tue Sep 12 19:01:42 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* More Quartz modifications.  Now has QuartzDbTable class reasonably
	  fully specified.

Tue Sep 12 17:48:49 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Quartztest compiles and works.  (Passing is not yet likely, though)

Tue Sep 12 17:45:40 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* term_exists() methods in each backend now assert that the termname
	  passed in is not of zero length.  The API should throw exceptions
	  before a null term gets down to this level (though currently the
	  post and position iterators don't do this...).

Tue Sep 12 17:33:01 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Implemented OmIndexerNode::set_config_string() and added
	  OmIndexer::set_node_config() to make it useful.

Tue Sep 12 17:12:30 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* The Java bindings now seem to work again, although the automatic
	  apitest converter doesn't.

Tue Sep 12 16:36:41 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Removed final bits of Berkeley DB from Quartz, and conditional
	  compile around header files (which was for includetest's benefit).

	* Added yet more classes to Quartz.  Still doesn't do anything.

Tue Sep 12 16:32:30 BST 2000 Olly Betts

	* Added reference counting to an instantiation of SleepycatTermList
	  which I'd missed.

Tue Sep 12 15:23:09 BST 2000 Olly Betts

	* Oops, AndMaybePostList didn't compile...

Tue Sep 12 14:44:26 BST 2000 Olly Betts

	* Fixed problem with OrPostList decomposing into AndMaybePostList at
	  the very start (only happens with a percentage cut-off threshold).

Tue Sep 12 14:15:13 BST 2000 Olly Betts

	* includetest.cc now depends on findheaders.pl.

	* findheaders.pl now copes with wrapped lines in Makefile.in (cvs
	  automake leaves them wrapped - last release version unwrapped them).

Tue Sep 12 12:35:49 BST 2000 Olly Betts

	* *PostList and *TermList now keep a reference to their parent database
	  so they'll continue to work if all other references to the database
	  die (tested by termlist3).

Tue Sep 12 12:34:40 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* The Java stuff now actually compiles.

Tue Sep 12 09:21:48 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Remove dependency of quartz on Berkeley DB 3.1, in configure.in

	* Small changes to quartz - added a QuartzDbTable class for managing
	  database tables.

Mon Sep 11 18:39:58 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Some updates to Java half of the Java bindings.  The native half
	  still needs some fixing, as do the test classes.

Mon Sep 11 18:34:30 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix from Martin for DB database skip_to problem - reenabled skip_to
	  in DBPostList.

Mon Sep 11 17:48:50 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* OmRefCntPtr updated to deal with conversions between different
	  pointer types.

Mon Sep 11 17:43:13 BST 2000 Olly Betts

	* Added test to internaltest to reproduce OmRefCntPtr::BypassRefStart
	  problem.

Mon Sep 11 16:15:54 BST 2000 Olly Betts

	* Removed useless default value for dest_ on OmRefCntPtr
	  BypassRefStart constructor.

Mon Sep 11 14:57:42 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Stopped OmDatabase::postlist_{begin,end} from being virtual.

Mon Sep 11 14:00:04 BST 2000 Olly Betts

	* Added .daflimsy, .db, and .dbflimsy to .cvsignore.

Mon Sep 11 13:31:38 BST 2000 Olly Betts

	* Fixed OmTermListIterator so termlist2 test passes.

Mon Sep 11 12:28:13 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* If a test fails and leaks, then don't rerun it (ie, only rerun if
	  it passes but leaks)

Mon Sep 11 11:56:29 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Implemented OmIndexerNode::invalidate_outputs()

	* Added new methods get_element() (the same as operator[]) and
	  append_element() to Record.

	* Made the output of operator<<(ostream &, Record) more compact.

Mon Sep 11 11:21:27 BST 2000 Olly Betts

	* Fixed compiler warning in string_to_ommsetitems in non-debug builds.

Mon Sep 11 10:28:43 BST 2000 Olly Betts

	* Test suite now exercises flimsy version of da backend, and both
	  heavy duty and flimsy versions of db backend.

Fri Sep  8 20:10:06 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix problem with OmPostListIterator's internals not being reference
	  counted, and copy still being allowed; internals are refcnt again,
	  and copy and assignment operations are fully defined.
	  OmTermListIterators and OmPositionListIterators are still broken.

Fri Sep  8 18:42:49 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* In delve, ensure that recno's are in sorted order.

Fri Sep  8 18:41:19 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* In MultiPostList::skip_to(), don't call get_docid() if already
	  at_end().

Fri Sep  8 17:31:28 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Change implementation of DBPostList::skip_to to repeatedly call
	  next(), as temporary work around for a bug.

Fri Sep 08 16:41:17 BST 2000 Olly Betts

	* Om*Iterator ought to now work as STL iterators; added test termlist2
	  for this - but it currently fails so is disabled.

	* Martin has fixed problem in makeDA so termlist1 now passes with da
	  backend.

Fri Sep  8 16:34:23 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Delve can now display several termlists, several postlists, or
	  lots of positionlists.

Fri Sep  8 12:02:05 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix Asserts in MultiPostList::skip_to(), and small bug in
	  MultiPostList::next();

	* debugging info to DBDatabase::skip_to().

	* delve now displays lists of docids or terms one per line, for easier
	  post-processing.

Fri Sep 08 11:02:53 BST 2000 Olly Betts

	* Reenabled termlist1 for DA backend so Martin can investigate bug.

Fri Sep 08 10:44:53 BST 2000 Olly Betts

	* Removed a number of superfluous semicolons.

Fri Sep  8 09:26:00 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add debugging to all methods of OmPostListIterator, and make
	  get_description tell the current position.

	* Fix MultiPostList - it was never getting off the initial position.

	* Correct some messages in db_database.cc which reported being from
	  a DA database.

Thu Sep  7 23:30:39 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add to PostList next() and skip_to() methods which don't take a
	  minimum weight, for use outside the matcher, or when moving
	  postlists to beginning for a MultiPostList.

Thu Sep  7 23:05:54 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Extra debugging stuff added to OmPostListIterators.

	* Remove assertions in termlist, positionlist and postlist at_end()
	  methods which check that list is not at beginning.  Calling at_end()
	  at the beginning of such lists is now valid, (and returns false, even
	  if the list is empty).

Thu Sep  7 18:44:51 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added debug information to DB database reading code.

	* Fix a typo in matcher.  (om_weight -> om_docid)

Thu Sep 07 17:44:24 BST 2000 Olly Betts

	* net/socketcommon.cc: Improved a couple of exception messages.

Thu Sep 07 16:15:17 BST 2000 Olly Betts

	* Fixed a problem with distributing NEAR and PHRASE.

Thu Sep  7 13:45:21 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Change om_tostring(double) so that it doesn't pad with spaces,
	  fixing all the network stuff.  (Whoops)

Thu Sep  7 11:50:39 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Various other fixes needed to compile with --disable-pthread-support

Thu Sep  7 11:03:32 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix to make omdebug.cc compile when --disable-pthread-support
	  is specified to configure.

Thu Sep  7 01:40:40 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added extra debugging to matcher to help track down reported
	  bug.

	* Changed value of C in bm25weight to 0 to see if this helps Webtop
	  performance in pathological cases.

	* Fixed threadtest.cc so that it runs again.

Wed Sep  6 17:44:04 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* <param> added to the test.dtd

	* mt_vector added as a message type separate from mt_record

Wed Sep 06 17:37:50 BST 2000 Olly Betts

	* Tom Mortimer gets a well deserved mention in the AUTHORS list for
	  bug reporting.

Wed Sep 06 16:32:01 BST 2000 Olly Betts

	* website now uses viewcvs - another TODO bites the dust.

Wed Sep  6 15:43:31 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Outputs other than "out" can be used for the output of the whole
	  network.

	* Added <param> tags to pass configuration info to nodes from the
	  XML description.  OmIndexerNode::get_config_string() actually
	  implemented, plus OmIndexerNode constructor now takes an
	  OmSettings.

	* OmIndexerNode methods set_output_{string,int,double,record} renamed
	  to overloaded set_output.

	* New Record constructor for initialising from a vector, along with
	  accessor functions get_vector_length() and operator[].  The
	  stream insertion operator uses these to recursively print out the
	  values.

Wed Sep 06 13:34:24 BST 2000 Olly Betts

	* Opening a termlist for a document which is not present now always
	  throws OmDocNotFoundError (da and db backends need checking)

	* Updated TODO.

Wed Sep 06 11:31:00 BST 2000 Olly Betts

	* Fixed problems with distributing NEAR/PHRASE over subexpressions.

Wed Sep 06 09:28:04 BST 2000 Olly Betts

	* Added omtermlistiteratorinternal.h to list of files to distribute.

Tue Sep  5 18:36:43 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a new setting "remote_timeout", used to configure the
	  timeout (in milliseconds) used before giving up on network
	  connections.  (The default is 10,000 milliseconds or 10 seconds)

	* Added new option --timeout to set the timeout on the tcp server
	  side.

Tue Sep 05 15:51:07 BST 2000 Olly Betts

	* Added some items to TODO.

Tue Sep  5 15:21:13 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Correct directory tag in indexer/indexgraph/dir_contents

Tue Sep 05 14:28:40 BST 2000 Olly Betts

	* apitest: Added multidb5 - test of AND with multidatabase.

	* multi backend tweaks.

	* NetworkDatabase: pruned dead code.

	* Minor doc comment corrections.

	* apitest: multidb* tests were searching for "inmemory" unstemmed -
	  corrected.

Tue Sep  5 11:48:54 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed a double-deleting bug in indexer

Tue Sep 05 11:25:21 BST 2000 Olly Betts

	* apitest: Added multidb5 - test of AND with multidatabase.

Tue Sep  5 10:49:18 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Re-added OmTypeError with slightly different comment.

Tue Sep 05 08:29:04 BST 2000 Olly Betts

	* Added missing class: OmTypeError.

Mon Sep  4 18:30:39 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Reduced the number of copies of messages needed in indexing
	  networks.

	* Added some type safety to the Record class.

Mon Sep 04 17:40:18 BST 2000 Olly Betts

	* Updated TODO.

Mon Sep 04 17:22:29 BST 2000 Olly Betts

	* Overhauled MultiDatabase and MultiPostList: Complexity used to
	  be O(# of subdatabases) in many operations, now constant time;
	  Removed termname cache (no evidence that same termname is often
	  looked up more than once).

	* Fixed a couple of stupid compiler warnings in localmatch.cc.

Mon Sep  4 16:48:51 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Cleaned up the registration of new indexer nodes a bit.

	* Prefixed some of the types with "Om".

Mon Sep 04 14:42:56 BST 2000 Olly Betts

	* Implemented MultiPostList::get_position_list.

Mon Sep 04 12:05:40 BST 2000 Olly Betts

	* Moved multidbN tests together.

Mon Sep 04 09:30:38 BST 2000 Olly Betts

	* Implemented OmTermListIterator.

	* delve now implemented using only API calls.

Sun Sep 03 15:58:07 BST 2000 Olly Betts

	* Implemented OmPositionListIterator.

	* Fixed up operator== on OmPostListIterator.

	* Updated delve to use new Om*Iterator classes.

Sun Sep 03 13:06:31 BST 2000 Olly Betts

	* Added OmPostListIterator::get_description method.

	* Fixed maxorterms1 test to work with da backend.

Sun Sep 03 11:55:33 BST 2000 Olly Betts

	* Checked in missing new sources.

Sat Sep 02 18:30:48 BST 2000 Olly Betts

	* Implemented OmPostListIterator.

Fri Sep 01 18:36:09 BST 2000 Olly Betts

	* apitest: Split off api_db.cc - test requiring a database.

Fri Sep 01 18:18:08 BST 2000 Olly Betts

	* apitest: Split off api_posdb.cc - tests requiring positional info.

Fri Sep 01 16:51:52 BST 2000 Olly Betts

	* apitest: pctcutoff1 now works with DA backend; tests which need
	  document length are now a separate category.

Fri Sep 01 15:52:06 BST 2000 Olly Betts

	* apitest: Split off nodb tests into api_nodb.cc.

	* Testsuite "-f" switch is now pointless - removed.

Fri Sep 01 13:22:33 BST 2000 Olly Betts

	* apitest now uses test helpers in many more tests.

Fri Sep  1 13:12:09 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Change find invocations to be portable, in docs/Makefile.am and
	  docs/mkdocs.pl.in

Fri Sep  1 12:57:59 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Correct sense of test for presence of doxygen.  How we never
	  noticed this before eludes me...

Fri Sep 01 11:20:03 BST 2000 Olly Betts

	* Moved some test helper functions from apitest.cc to testsuite.cc.

Fri Sep 01 10:06:00 BST 2000 Olly Betts

	* testutils.h and testsuite.h moved from common to testsuite.

Thu Aug 31 18:07:33 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Implemented the OmIndexerNode bits to handle primitive types
	  as well as records.  Primitive types are converted to/from
	  records as needed.

	* Added support for "ANY" type which is compatible with any
	  other.  (Used for "split" node, for example)

Thu Aug 31 17:50:00 BST 2000 Olly Betts

	* Headers to be used by include test are now found by parsing
	  Makefile.in-s which fixes several niggles.

Thu Aug 31 16:08:00 BST 2000 Olly Betts

	* Added tests for NEAR/PHRASE distributing over sub-expressions.

Thu Aug 31 15:43:07 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Sorted out some of the enum bits in OmIndexer

	* Check that the same node type isn't registered more than once.

	* Stop building of "nodetest" in indexer which depends on libomus

	* Building without remote backend should now work.

Thu Aug 31 15:36:00 BST 2000 Olly Betts

	* Should now distribute NEAR/PHRASE over sub-expressions - untested.

Thu Aug 31 11:41:00 BST 2000 Olly Betts

	* Window size for NEAR and PHRASE now defaults to number of
	  subqueries.

	* NEAR and PHRASE can now be built with OmQuery pair constructor.

Thu Aug 31 13:29:20 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* OmIndexer type-checking now seems to work.

Thu Aug 31 12:20:27 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added checking for hstrerror in -lresolv (needed by Solaris)

	* Added HAVE_LIBXML define

	* indexer/indexgraph/ now built if libxml is found

	* indexer/indexgraph/ skipped from includetest (since it can't find
	  parser.h)

	* stemtest.pl will skip checking with the random data/text if
	  $OM_STEMTEST_SKIP_RANDOM is set.

Thu Aug 31 11:41:00 BST 2000 Olly Betts

	* Updated TODO.

Thu Aug 31 11:29:00 BST 2000 Olly Betts

	* Removed strange special case which allows assignment of an
	  OmWritableDatabase to an OmDatabase which is actually a reference
	  to an OmWritableDatabase.

	* Make OmWritableDatabase::get_document() into a const method in the
	  code as well as the header.

	* Added database assignment test.

Wed Aug 30 19:15:29 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Partially implemented type-checking in OmIndexer

Wed Aug 30 18:21:02 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add a test to the quartz testsuite - currently doesn't compile.

Wed Aug 30 17:50:42 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Make OmWritableDatabase::get_document() into a const method -
	  doesn't change anything.

Wed Aug 30 15:10:09 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Put guards in indexergraph header file to make it empty if
	  libxml is not available.  (For includetest)

Wed Aug 30 15:10:00 BST 2000 Olly Betts

	* Added guards to sleepycat headers so that they are empty if
	  sleepycat is disabled - this is to make includetest pass.

Wed Aug 30 14:49:00 BST 2000 Olly Betts

	* tests/Makefile.am: use ${srcdir} to find sources for extra CXXFLAGS
	  rules so compiling outside the source tree works.

Wed Aug 30 14:34:07 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Put in guards to headerfiles in quartz so that the files are
	  empty if quartz isn't configured on - this is to make includetest
	  pass.

Wed Aug 30 14:13:19 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add a quartztest testsuite in the Quartz database directory.  That
	  should save me some compile time...

Wed Aug 30 12:49:00 BST 2000 Olly Betts

	* apitest: declare tests static - we then get a warning when a test
	  isn't used and it may speed up linking.

Wed Aug 30 12:34:23 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Now pass query length information in remote matches.

	* Incremented remote protocol version.

Wed Aug 30 11:03:11 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Bug fixes to the modified indexing framework mini-test

Wed Aug 30 10:37:00 BST 2000 Olly Betts

	* tests/Makefile.am: use CXXCOMPILE and LTCXXCOMPILE for compiling
	  with extra CXXFLAGS.

Tue Aug 29 19:22:52 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Partially implemented the new indexer interface

Fri Aug 25 16:58:39 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Moved stuff around for the new indexing stuff.

Fri Aug 25 12:08:00 BST 2000 Olly Betts

	* Minor tweaks to apitest and matcher.

Thu Aug 24 19:16:53 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* More modifications to Quartz - now passes modifications made to
	  PostLists and PositionLists into an object designed to store and
	  manage them - nothing written to databases still, though.

Thu Aug 24 16:55:59 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added a documentation comment, a fixme and a todo.

Thu Aug 24 15:53:50 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed potential core-dump bug in OmSocketLineBuf

Thu Aug 24 15:04:04 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Various modifications to quartz database: compiles again.

Thu Aug 24 13:31:19 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add new, private, constructor of OmRefCntPtr, and make the pointed
	  to class a friend, so that a class can give out refcntpointers
	  to itself, even after someone else already has such a pointer.

Thu Aug 24 12:58:00 BST 2000 Olly Betts

	* Fixed two missed uses of get_irdatabase().

Thu Aug 24 11:14:55 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Change OmDatabase::InternalInterface::get_irdatabase() to
	  OmDatabase::InternalInterface::get_multi_database().  Return more
	  helpful error if a multi db is asked for without specifying any
	  databases.

Thu Aug 24 11:05:44 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Updated HTML docs generated by gvim.

Wed Aug 23 15:29:00 BST 2000 Olly Betts

	* Updated docs to reflect OmDatabaseGroup merging into OmDatabase.
	  Can't update HTML generated from C++ by gvim though.

Wed Aug 23 15:10:00 BST 2000 Olly Betts

	* WARNING: Incompatible changes to API!

	* OmDatabaseGroup merged into OmDatabase.  Upgrading your code should
	  just be a matter of replacing OmDatabaseGroup with OmDatabase.

Wed Aug 23 13:11:59 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added classes to store a set of modified quartz database blocks.

	* Various other mods to quartz database.

Wed Aug 23 11:28:00 BST 2000 Olly Betts

	* omsettings.h: added list of valid backends to doc comment.

Tue Aug 22 19:02:14 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Python bindings partly moved into the present.

Tue Aug 22 18:26:00 BST 2000 Olly Betts

	* apitest now tests query length and within query frequency (wqf).

	* Fixed max_or_terms to preserve the query_size when an OR collapses
	  to just one sub-query.

	* The query length now makes it through to IRWeight (was always
	  passing 1).

	* remote backend currently fails test qlen1 because the query length
	  isn't currently passed in the serialisation of an OmQuery.

Tue Aug 22 18:19:16 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add class to hold modified blocks in a quartz DB.  Doesn't compile
	  yet, but then, its not linked into the build system either. ;-)

Tue Aug 22 17:00:49 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added some proof-of-concept XML-generated indexer network code.

Tue Aug 22 16:59:11 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix documentation comment in omsettings to refer to remote instead
	  of network.

Tue Aug 22 11:40:00 BST 2000 Olly Betts

	* Rearranged the file layout of the OmDatabase* classes to be rather
	  more sane.

Mon Aug 21 17:16:26 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Declare this to be version 0.3.0

Mon Aug 21 17:13:00 BST 2000 Olly Betts

	* Now use within query frequency and query length information in
	  match.

Mon Aug 21 16:55:57 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add release note to NEWS.

Mon Aug 21 16:18:00 BST 2000 Olly Betts

	* Added a few items to TODO.

Mon Aug 21 15:28:00 BST 2000 Olly Betts

	* WARNING: Incompatible changes to API!

	* om_queryop -> OmQuery::op, OM_MOP_* -> OmQuery::OP_*

Mon Aug 21 15:03:00 BST 2000 Olly Betts

	* Overhauled TODO list and added difficulty column.

Mon Aug 21 14:12:00 BST 2000 Olly Betts

	* Make apitest actually run implicitendsession test.

Mon Aug 21 13:52:34 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Update html versions of simpleexample code, to reflect new API.

	* Add quartz_modifications.cc so that quartz db will link.

Mon Aug 21 13:16:00 BST 2000 Olly Betts

	* Added test that sessions get ended correctly if class is destroyed
	  without end_session() being explicitly called (test only works in a
	  debug build).

	* MultiMatch::match() -> MultiMatch::get_mset()

Mon Aug 21 12:44:32 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* using_stemmers.html updated, to use void * rather than struct
	  <foo> *, and to make the example code compile and work correctly.

Mon Aug 21 12:13:00 BST 2000 Olly Betts

	* Removed lingering traces of get_max_weight().

	* Pruned TODO.

Mon Aug 21 11:57:00 BST 2000 Olly Betts

	* OmDocumentTerm::add_posting now first checks for the case where it
	  can simply append the new positional info (since positions are
	  usually added in increasing order)

Mon Aug 21 11:30:00 BST 2000 Olly Betts

	* LocalMatch::get_max_weight() isn't externally visible, so removed it
	  entirely

Sun Aug 20 18:09:00 BST 2000 Olly Betts

	* Corrected minor typos, etc in documentation.

Sun Aug 20 17:35:00 BST 2000 Olly Betts

	* All externally visibile references to "net"/"network" backend now
	  call it "remote".

Sun Aug 20 17:12:00 BST 2000 Olly Betts

	* Started to rename net/network backend to remote (passes make check
	  at this point).

Sun Aug 20 16:17:00 BST 2000 Olly Betts

	* Overhaul of LocalMatch: get_max_weight deprecated and now just
	  throws OmUnimplementedError; various class members now just local
	  to get_mset; renamed recalculate_maxweight to recalculate_w_max
	  since it forces recalculation of w_max and not max_weight.

	* includetest now checks that found headers are actually files
	  and ignores any headers in bindings (not just java related ones).

Sun Aug 20 14:19:00 BST 2000 Olly Betts

	* Added support for muscat36 da backend to backendmanager (uses
	  makeDA program, so only works on Linux).  Some tests won't work
	  with this backend as it doesn't support word-based positional
	  information or document lengths.

	* Sucked repeated code for running tests in apitest into a macro.

	* Can now restrict apitest to use one backend like so:
	  OM_TEST_BACKEND=inmemory ./apitest

Sat Aug 19 19:24:00 BST 2000 Olly Betts

	* nettest now guesses srcdir like apitest does.

Sat Aug 19 18:39:00 BST 2000 Olly Betts

	* Added testcase for handling of multiple postings of a term at the
	  same position (adddoc1).

	* Fixed wdf handling in inmemory backend.

	* Fixed handling of writable databases in BackendManager (they can't
	  safely be reused as the previous test may have altered the
	  contents).

	* Added new test category to apitest: tests that need a writable
	  database.

Sat Aug 19 15:01:00 BST 2000 Olly Betts

	* Muscat36 db backend now autodetects flimsy vs heavyduty

Sat Aug 19 12:30:00 BST 2000 Olly Betts

	* Naming consistency - now always say "sleepycat" never "sleepy".
	  Only externally visible effect is in options to configure.

	* A few header multiple inclusion guards were misnamed - fixed.

Fri Aug 18 17:49:00 BST 2000 Olly Betts

	* Pruned completed and no-longer-relevant tasks from TODO.

	* DatabaseBuilder now throws OmFeatureUnavailableError rather than
	  OmOpeningError if you try to use a backend which isn't compiled in.

	* Added checks for correct handling of unknown and unavailable
	  backends by DatabaseBuilder.

Fri Aug 18 16:22:00 BST 2000 Olly Betts

	* WARNING: Incompatible (minor) changes to API!

	* OmSettings::get_value* -> OmSettings::get*
	  OmSettings::set_value -> OmSettings::set

Fri Aug 18 16:03:39 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix to configuration system so that it runs the test programs -
	  it should now complain if the wrong versions of sleepycat libraries
	  are lying about.

Fri Aug 18 15:39:00 BST 2000 Olly Betts

	* WARNING: Incompatible (minor) changes to API!

	* OmMatchDecider::operator() now takes a const reference rather than
	  a const pointer.  Removed warning that arguments to this method
	  are highly likely to change.

	* Changed a few methods to take const references to avoid
	  unnecessary object copying (changes API, but code using API won't
	  need changing).

Fri Aug 18 14:31:00 BST 2000 Olly Betts

	* OmBatchEnquire::batch_result no longer public - instead
	  OmBatchEnquire::Internal is a friend class.

Fri Aug 18 13:58:00 BST 2000 Olly Betts

	* Added documentation of valid settings to OmSettings doc comments.

Fri Aug 18 12:34:00 BST 2000 Olly Betts

	* Dervied classes of IRDatabase now implement do_open_post_list,
	  with open_post_list now a wrapper in the base class which checks
	  whether the term exists and returns EmptyPostList if it doesn't.

	* LocalMatch: EmptyPostList-s now always have a weight.

	* apitest: Added maxorterms3 to check that maxorterms doesn't affect
	  results if no term are discarded; fixed qterminfo1 as non-existent
	  terms now *do* have a weight.

	* backendmanager.cc: Now close and reopen a freshly built sleepycat
	  database as a workaround for problems with the sleepycat backend.

	* testsuite.cc: Now exit after display syntax message.

Thu Aug 17 20:47:48 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix some documentation comments in common/database.h and
	  include/om/omdatabase.h

	* Begun to implement structure for organising database modifications
	  in Quartz database - added QuartzModifcations.  Also added a mutex
	  to protect the QuartzDatabase class from concurrent access.

	* Ensure that all database types won't have an exception thrown
	  from their destructors: catch any thrown by internal_end_session()
	  and discard them.  Is this safe? - is possible to have two
	  exceptions in progress at once; one causing the destructor to
	  be called, and one inside the destructor (although this won't
	  escape the destructor).

Thu Aug 17 17:16:00 BST 2000 Olly Betts

	* Merged select_query_terms into build_query_tree

Thu Aug 17 16:58:12 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added QuartzDBManager, to manage the databases files and
	  environments in use.

Thu Aug 17 16:46:00 BST 2000 Olly Betts

	* A few tweaks to NetworkMatch

Thu Aug 17 16:14:00 BST 2000 Olly Betts

	* Weighting scheme now specified in OmSettings; termweights now
	  deleted by LeafPostList rather than LocalMatch.  No changes to
	  external APIs this time!

Thu Aug 17 14:54:00 BST 2000 Olly Betts

	* To speed things up with debug builds, DEBUG_CALL and
	  DEBUG_CALL_STATIC now check debug type earlier and avoid building
	  strings if this debug message is disabled.

Wed Aug 16 21:18:03 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Quartz throws OmInimplementedError from all its public methods.

	* Added a FIXME in all IRDatabase (and subclass) destructors - mustn't
	  throw exceptions.

Wed Aug 16 17:12:00 BST 2000 Olly Betts

	* WARNING: Incompatible changes to API!

	* Replaced OmMatchOptions and OmExpandOptions with OmSettings.

Wed Aug 16 17:05:04 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed a bug which could cause a TCP server to loop nastily if
	  an exception were thrown.

Wed Aug 16 13:53:00 BST 2000 Olly Betts

	* Fixed up a few mismatched OmSettings parameter names.

Wed Aug 16 12:41:00 BST 2000 Olly Betts

	* WARNING: Incompatible changes to API!

	* OmSettings used to replace DatabaseBuilderParams and ad-hoc
	  passing of database parameters as vector<string>.

	* Added OmSettings::get_description() and macros so it can be
	  written to streams

	* OmSettings values can now also be bool or vector<string>

	* Backend types da_flimsy/da_heavy replaced by da with heavyduty
	  parameter.  Similarly for db_* backends.

Wed Aug 16 12:08:00 BST 2000 Olly Betts

	* stemtest.pl now complains if srcdir isn't set

Tue Aug 15 21:13:22 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Various bits of work done to Quartz.  Now opens a DB environment,
	  or would if it were given an appropriate path.

Tue Aug 15 20:39:45 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Correct library name to link against for BerkeleyDB 3.1, from libdb
	  to libdb_cxx

Tue Aug 15 20:24:19 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added OmFeatureUnavailableError exception, to be thrown when a
	  feature is not compiled in, or otherwise unavailable.

Tue Aug 15 15:19:45 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Incorporated Jon Fielder's patches to TcpServer - it's now a
	  forking server rather than serving connections one at a time.

Tue Aug 15 14:47:06 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Link quartz database into DatabaseBuilder and testsuite.  Now
	  ready to begin writing it. :)

Tue Aug 15 11:27:04 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added initial (empty) quartz_database.{cc,h} files, so that
	  distcheck will work again.

Tue Aug 15 11:24:51 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Removed netprogs/omnetclient.cc - unused file.

Mon Aug 14 19:11:03 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Python tests up to 25 pass, 3 fail (plus test_alwaysfail).

Mon Aug 14 18:42:05 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Java and SWIG bindings brought up to date with recent changes
	  to OmWritableDatabase

	* Python version of apitest.cc now has 29 tests converting, of which
	  21 pass.

Mon Aug 14 15:50:00 BST 2000 Olly Betts

	* MultiDatabase::MultiDatabase(const DatabaseBuilderParams & params)
	  now always throws OmInvalidOperationError.  The other constructor
	  is a much less awkward way to construct a multidatabase and
	  removing it greatly simplifies DatabaseBuilderParams.

Mon Aug 14 15:13:00 BST 2000 Olly Betts

	* Removed default stuff from OmSettings and added methods to read and
	  write integer and real values.

Mon Aug 14 12:36:01 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added directory and build stuff for new backend - quartz.  Not
	  compiled by default (but then, there's no code there yet either...)

Fri Aug 11 19:59:32 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* IRDatabase destructor no longer tries to end session, since
	  derived classes will have been destroyed: added (protected)
	  internal_end_session() instead, which derived class destructors
	  should call.

	* Fix failure to initialise IRDatabase::session_in_progress and
	  IRDatabase::transaction_in_progress

Fri Aug 11 19:25:10 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add to internaltest a test that nested exceptions work correctly.

Fri Aug 11 19:09:30 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* API change:  Replaced OmWritableDatabase::end_transaction() by
	  OmWritableDatabase::commit_transaction() and
	  OmWritableDatabase::cancel_transaction().

	* IRDatabase no longer inherits from IndexerDestination: obselete
	  class.

	* Modified IRDatabase to support new writable database API model,
	  giving it public methods to match.  These public methods ensure
	  that the sessions and transactions are appropriately started
	  and ended, and then call private virtual do_* methods, which
	  are overridden to perform the actions.

	* Modified backend Database classes to have stub methods so the
	  system works with the new writable database model.

Fri Aug 11 18:42:23 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Yet more Python updates.  17 out of the 20 tests currently
	  translated into Python pass.

Fri Aug 11 14:14:28 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* More Python updates - 9 out of the 20 tests now pass.

Thu Aug 10 18:05:52 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Updates the Python/SWIG bindings.  3 tests (out of 20 which are
	  translated) currently pass.

Thu Aug 10 17:12:31 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add stub implementations for new methods in OmWritableDatabase,
	  which throw OmUnimplementedError exceptions, so that the python
	  port can proceed.

Thu Aug 10 12:01:18 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Declare this to be version 0.2.1

Wed Aug  9 17:21:33 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Removed annoying exception messages from omprogsrv (which turned
	  up in net->absentfile1 test)

Wed Aug  9 17:05:52 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Apitest now runs with the network backend by default.  Two of the
	  tests are only run for the local databases.

Wed Aug  9 15:29:58 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Documentation comment fix in OmMSet.

Wed Aug  9 15:09:14 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Cleaned up the MSet passing internals.  The various get_mset
	  functions now pass things around in OmMSets rather than as parts.

	* mbound now works with network backend.

	* Fixed the match options serialisation.

Wed Aug  9 14:54:30 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add detection of BerkeleyDB version 3.1 to configure.in, ready
	  for new backend.

Tue Aug  8 17:50:47 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Use auto_ptr's and similar to protect TermLists being manipulated by
	  OmExpand so that they're not leaked if an exception happens.

Tue Aug  8 16:36:18 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add test of mbound.

Tue Aug  8 16:24:27 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add automatic detection of socklen_t, so that we don't get nasty
	  warnings on Linux just because of solaris.

Tue Aug  8 16:04:09 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Patch to log where connections are from in tcpserver.cc, by
	  Jonathan Fielder of Webtop.

Tue Aug  8 15:58:59 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Implemented some more of the support code for Python apitest

Tue Aug  8 14:49:46 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Implement do_get_all_keys() for DA and DB databases.  Untested.

Tue Aug  8 12:26:13 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix potential concurrency problem in big file descriptor stuff:
	  although it was very unlikely to have actually caused a problem.

Mon Aug  7 18:41:10 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Progress on apitest Python translation.  test_trivial runs.

Mon Aug  7 18:03:16 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* API addition: added OmInvalidOperationError to report invalid
	  API usage, for example, ending a session when one hasn't been
	  begun.

	* API Change: changed OmWritableDatabase considerably, so that it
	  has begin_session() and end_session() methods instead of lock()
	  and unlock() methods, amongst other things.

Fri Aug  4 18:52:56 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Split apitest_to_java into the separate packages it contained

	* Started work on the Python apitest module

Fri Aug  4 15:32:30 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* More tests work from Java.  (31 pass)

Fri Aug  4 12:38:59 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Now 25 tests pass in Java, and test_alwaysfail has been disabled.

Fri Aug  4 11:43:00 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed an indexing buglet which caused results of the simplequery2 to
	  be different under Java.  Now 22 pass, 4 fail (including alwaysfail)

Thu Aug  3 17:40:38 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Now 21 tests pass, 5 fail (including alwaysfail) - databases
	  weren't being flushed properly when created.

	* ApiTestFuncs.main() now understands some of the normal testsuite
	  command-line options.

Thu Aug  3 14:39:58 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Java automatically converted apitest now runs 25 tests (and fails
	  14 of those).

Wed Aug  2 18:36:03 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Some more improvements to the apitest converter for Java.

Wed Aug  2 18:09:43 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added OmDatabaseCorruptError - for when a database is corrupt.

Wed Aug  2 14:29:08 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added description of OM_NEW_TRAP[_COUNT] environment variables to
	  HACKING.

Wed Aug  2 13:28:29 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix problem in internaltests checking of the testsuites leak
	  detection.

Wed Aug  2 12:45:11 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added instructions for compiling with STLport to INSTALL.

Wed Aug  2 12:13:39 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* If a test appears to have had a memory leak, the testsuite runs the
	  test a second time to find out if it happens again - and if not
	  decides that everything it fine.

Tue Aug  1 19:05:41 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Testsuite displays addresses in hex.

Tue Aug  1 19:00:56 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added ar-wrapper-solaris to the distribution.

Tue Aug  1 18:16:04 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Hacked libtool (actually ltconfig) to support building under
	  Solaris CC.  Also added an ar wrapper for the same reason.

Tue Aug  1 17:37:57 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Changed even more DebugMsgs with endls into DEBUGLINEs: now
	  compiles library.

	* Disable support for adding endl() and flush() to a om_ostringstream.
	  This was very hackily done, and broke with different compilers or
	  STL port.

	* Fix typo in RJB_FIND_STLPORT macro, so that the correct path is
	  given for finding the library.

Tue Aug  1 17:12:03 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Changed more DebugMsgs with endls into DEBUGLINEs: backends now
	  finished.

Tue Aug  1 17:07:10 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add explicit std:: to things in sleepycat backend, so that it will
	  compile with stricter compilers.  Convert some DebugMsgs with endls
	  into DEBUGLINEs.

Tue Aug  1 16:08:04 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* stemtest and delve now compile under Solaris CC.

Tue Aug  1 15:41:23 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add autoconf support for compiling with STLport.

Tue Aug  1 15:39:50 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Change C++ style comments in acconfig.h into C style comments.

Mon Jul 31 19:05:43 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Updates to the Perl and Python test scripts, and an extra
	  Makefile dependency.

Mon Jul 31 15:41:37 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixes and updates to the SWIG bindings.  Perl5 has done its
	  first actual query (using an inmemory database).

Fri Jul 21 14:37:01 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* A couple of tweaks for Solaris.

Fri Jul 21 12:26:20 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed a reported memory leak in apitest on Solaris

	* Extra debugging facilities for finding memory allocation problems
	  in testsuite programs.
	  If OM_NEW_TRAP is set in the environment with a hex value, then
	  global operator new() will abort() when that address is allocated.
	  If OM_NEW_TRAP_COUNT is set to a number n, then only abort on the
	  nth allocation returning the above address.

Thu Jul 20 19:08:53 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Progress on the apitest-to-Java script and support stuff.  A
	  few helper functions need adding, but about half of the test
	  functions translate ok.

Thu Jul 20 16:39:00 BST 2000 Olly Betts

	* Tweaks to doxygen makefile stuff.

Thu Jul 20 15:56:13 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* In DEBUGCALL, make sure that "this" is displayed as a pointer,
	  not as the description of an API object.

Thu Jul 20 15:03:38 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* More work on omstringstream, now understands char *, std::endl and
	  std::flush and a few new types.

	* Make omlocks include stdio.h

Thu Jul 20 13:01:51 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* stemtest.pl now has new options:

	  --no-random avoids running the tests with randomly generated junk

	  languages can be specified on the command line to only run tests
	  on one (or more) specified language.

Wed Jul 19 18:14:48 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a script to convert apitest into other languages.  So far
	  has a mostly working Java backend.

Wed Jul 19 17:38:23 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Replace om_inttostring and doubletostring by (overloaded)
	  om_tostring methods.  Implement for several other types.

	* Redo om_ostringstream class so that it is self contained, and
	  doesn't depend on the system's streambuf; hopefully enabling
	  us to get debugging output in multithreaded situations...

Wed Jul 19 17:35:16 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* The Java apitest now correctly runs test_pctcutoff1, with either
	  the sleepy or inmemory backend.

Wed Jul 19 15:59:31 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added get_description to Java OmMSet wrapper.

Wed Jul 19 11:17:00 BST 2000 Olly Betts

	* backends/sleepy/dir_contents: updated information about sleepycat
	  backend.

Tue Jul 18 19:14:45 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* The beginnings of a Java apitest.  One test implemented, which
	  doesn't seem to work.  Updates to BackendManager and a few
	  related bits.

Tue Jul 18 18:48:05 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Change threadtests output so that it doesn't use om_stringstream.

Tue Jul 18 17:12:49 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Debug system now prints out the (currently numeric) debug type
	  before the output, to make it easier to tune OM_DEBUG_TYPES

	* OM_DEBUG_TYPES=0 now means no debugging output, instead of all.

Mon Jul 17 19:35:05 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* The testsuite now has improved reporting of test failures.  It
	  tells you whether it was an exception, a normal fail, or a
	  memory leak (and some combinations).

	* Solaris portability tweaks.

Mon Jul 17 19:13:13 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* BackendManager now working from Java, at least for sleepy databases.

Sat Jul 15 11:05:00 BST 2000 Olly Betts

	* Updated AUTHORS file

Fri Jul 14 18:44:22 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Even closer to BackendManager working in Java.

Fri Jul 14 18:27:25 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Protect dubious tests in internaltest from compilers without
	  -fno-access-control

	* More portability fixes for the Solaris compiler.

Fri Jul 14 15:35:24 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Use -D_REENTRANT if pthreads are being used (fixes bugs on Linux,
	  at the least).

	* Remove further reference to C++ style IO in threadtest.

Fri Jul 14 14:16:27 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Rework debugging system so that it uses C style IO, and has
	  various other improvements.

Fri Jul 14 14:07:00 BST 2000 Olly Betts

	* Updated .cvsignore-s

Fri Jul 14 14:03:00 BST 2000 Olly Betts

	* Removed trailing whitespace from various files.

Fri Jul 14 12:28:00 BST 2000 Olly Betts

	* apitest: near1 and phrase1 now run boolean queries since we only
	  care which documents are returned, and not the ordering; added
	  regression test for PHRASE order bug fixed yesterday to phrase1

Thu Jul 13 19:13:15 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Now well on the way to reimplementing BackendManager in java, so
	  that we can run some real tests.

Thu Jul 13 18:21:00 BST 2000 Olly Betts

	* inmemory_positionlist.cc: removed suprious `;'.

	* localmatch.cc: fixed problem with phrase being passed vector of
	  PostList-s in wrong order.

	* Created delve utility to inspect posting lists, term lists, and
	  position lists.

Wed Jul 12 18:48:52 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Work on java bindings - OmWritableDatabase added.
	  OmDocumentContents still needs adding.

Wed Jul 12 17:19:25 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added test_msetzeroitems1 to apitest, to check that statistics are
	  correctly returned when an empty mset is requested.

Wed Jul 12 17:05:26 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added much debugging information to weight calculation, and
	  term frequency and weight stuff now appears to work.

Wed Jul 12 14:38:43 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* More work on returning term frequency and weight information.
	  Should now return correct term frequency, but all weights appear
	  to be 0. :(

Tue Jul 11 18:35:27 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* More work on returning term frequency and weight information.
	  Might even work now.

Tue Jul 11 13:04:00 BST 2000 Olly Betts

	* Changed various OmStem methods to take "const string &" instead of
	  "string"

Tue Jul 11 12:56:57 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Restored automake dependency checking for C files.

Tue Jul 11 12:54:15 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added test to apitest to check the get_term{freq,weight} methods
	  of OmMSet.  Currently fails, since these are unimplemented.

Tue Jul 11 11:37:00 BST 2000 Olly Betts

	* Added threadtest to .cvsignore

Tue Jul 11 11:04:00 BST 2000 Olly Betts

	* Added TODO for get_position_list() method on operators

Mon Jul 10 19:12:08 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* More Solaris portability fixes.

Mon Jul 10 18:35:27 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added Norwegian stemming algorithm, and linked it into the build
	  system.

Mon Jul 10 18:19:28 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add an internal interface to OmMSet, to allow access to the
	  term frequency and weight information internally for setting it.
	  Add code so that LocalMatch is passed the map to store the
	  information in.

	* Fix tests so that internaltest compiles with CVS automake.
	  Hopefully it will still work with old automake.

Mon Jul 10 17:45:57 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added more code to RunTest.java

Sat Jul  8 14:26:00 BST 2000 Olly Betts

	* struct ByQueryIndexCmp -> class ByQueryIndexCmp so doxygen will
	  document it

Fri Jul  7 18:18:07 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added OmDatabase to java bindings

Fri Jul  7 17:31:23 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added OmMSet::get_termfreq() and OmMSet::get_termweight() methods,
	  for getting information about the terms involved in the query.
	  Implemented the methods, but not yet the process of putting the
	  information they require into the OmMSet.

Fri Jul  7 15:44:18 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Remove MultiMatch::get_max_weight()

Thu Jul  6 19:01:32 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix concurrency problem ... in threadtest.  D'oh!

Thu Jul  6 18:01:23 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* More portability fixes.

Thu Jul  6 16:46:09 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix deadlock when calling get_matching_terms()

Thu Jul  6 16:33:45 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fix to the Solaris portability fixes.

Thu Jul  6 15:39:36 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* More Solaris portability fixes.

Thu Jul  6 13:49:20 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Correct concurrency problems in Muscat 3.6 databases.  Should now
	  be threadsafe (ie, multiple threads may safely access the same
	  database object - only one thread should access each derived
	  postlist object, however these are really iterators and this
	  can never happen when using the API, anyway.)

Thu Jul  6 13:18:21 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* A few more OmQuery uses added to RunTest.java

	* NEAR and PHRASE queries now supported from Java.

Thu Jul  6 12:23:26 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* The OmQuery constructors taking vector iterators now accept
	  FILTER, XOR, etc. as long as there are exactly two subqueries.

	* OmError exceptions are now also part of the debug logs.  (With
	  new tag OM_DEBUG_EXCEPTION)

	* includetest is now only compiled, not linked and run.

Thu Jul  6 10:55:43 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed a problem stopping OmLineBuf from compiling.

	* Removed Test.java, which shouldn't have been there in the first
	  place.

Wed Jul  5 18:44:11 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* More work towards compiling on Solaris with non-gcc.

Wed Jul  5 17:38:20 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix bug when OmDatabaseGroups are assigned (mutex was deleted
	  before its sentry)

	* Fix potential bug in omdebug.h

Wed Jul  5 16:51:51 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed buglet in -Wno-long-long checking for the C compiler.

Wed Jul  5 15:17:29 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Made some progress towards things compiling with Sun's CC.

Wed Jul  5 14:57:10 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* More debugging stuff: flush after each message, and correct a
	  couple of formatting wonkinesses.

Wed Jul  5 13:12:09 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Implement OmDocumentTerm::get_description() and
	  OmDocumentContents::get_description()

Wed Jul  5 12:22:32 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* More updates to the build system for java backends - the native
	  headers are now autogenerated

	* Added get_description() method to the OmQuery wrapper

	* Start of new Java test program

Wed Jul  5 11:43:29 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added danish stemming algorithm.

Wed Jul  5 11:33:00 BST 2000 Olly Betts

	* backends/database_builder.cc: backend list now in alphabetical
	  order; removed OM_ prefix from OM_DBTYPE_* (since they're now
	  internal to this file).

Wed Jul  5 11:10:56 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed incorrect test in apitest

Tue Jul  4 19:19:20 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added more debugging output for API calls.

Tue Jul  4 18:50:39 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added macros DEBUGAPICALL and DEBUGAPIRETURN for displaying
	  debugging messages tracing API calls.  Used for all appropriate
	  classes in omenquire.cc

Tue Jul  4 17:43:28 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* More java makefile tweaks.

	* New test program for java bindings, which so far checks that it
	  can stem a word.

Tue Jul  4 16:58:08 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added comments to ensure that things are changed in sync in omstem.

	* Changed type of window parameter in OmQuery constructors to
	  (consistently) be om_termpos.

Tue Jul  4 15:56:35 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Nasty automakefile hackery to get java stuff to compile properly.

Tue Jul  4 12:16:36 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix OmStem::get_available_languages(), and test it.

Tue Jul  4 11:28:23 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Some tweaks to the Java bindings - now compiles and a test class
	  will run and fail to find a database.

Mon Jul  3 18:39:29 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add introspection to OmStem.

Mon Jul  3 17:32:51 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed a bug in apitest - the nullquery1() test was in the wrong
	  list of tests (it _does_ depend on a backend) and wasn't really
	  strict enough (so still passed with a void database).

Mon Jul  3 16:52:52 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added get_type() method to OmError, to return a string describing
	  the class.

	* Changed omerror.h to use a macro to define the error classes, due
	  to excessive code replication.

Mon Jul  3 16:04:05 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* testsuite.cc wasn't compiling with debug disabled.

Mon Jul  3 15:18:55 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Implemented InMemoryPostList::get_position_list()

	* SleepyPositionList is now replaced by an InMemoryPostList -
	  implementation is same, only difference is where the initialising
	  values come from.

Mon Jul  3 14:28:06 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed ProgClient's destructor (was throwing an exception duplicating
	  work being done elsewhere, causing an abort under some circumstances.)

Mon Jul  3 14:11:23 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed stemtest so that it now works with the swedish data set.

Mon Jul  3 13:51:53 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix fake memory leak being reported in some conditions, due to
	  failure to initialise the debug object fully before starting the
	  testsuite.

	* Run phrase and near tests on each backend, but fail.  Inmemory to
	  be fixed in a moment: network failure doesn't matter yet, but
	  should be fixed soon.

Mon Jul  3 12:38:11 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Change some FIXME's to \todo's - the new doxygen tag.  This should
	  be used in most situations where we used to use FIXME, now.

Mon Jul  3 12:29:10 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added get_description() methods to all API objects, returning
	  a human readable description of the contents of the object.

	* Added output operators for API objects, so that you can do
	  "cout << omenquire;"

	* Improved debug messages when displaying API calls, so that full
	  information is given about the parameters and return types.

Sun Jul  2 17:17:14 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Updated doxygen configuration files for doxygen 1.1.5.

	* Configure now checks for dot tool, and sets doxygen config files
	  accordingly.

Fri Jun 30 16:04:19 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added an om_stringstream class as a simple implementation of
	  something like std::stringstream.

	* Debug messages now have a finer-grain lock to avoid entangling
	  of messages or deadlocks.

Fri Jun 30 12:48:34 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fixes to Makefile dependencies for internaltest.

Thu Jun 29 03:39:46 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix tests/Makefile.am so that internaltest links again.

	* Fix some deadlocks caused by Debugging mutex.  Then remove the
	  debugging mutex, because it causes more problems than it solves.

Thu Jun 29 03:13:12 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Display an initial debugging message before starting a test run,
	  thus avoiding a mistaken complaint of a memory leak.

Thu Jun 29 03:06:12 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix typo causing nettests to fail: was trying to open network
	  databases as writable.

Thu Jun 29 02:44:39 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Protected output of debug messages with a mutex, so messages
	  aren't tangled up.  Added DEBUGLINE() macro, which displays a
	  message which has a line to itself, said line starting with an
	  indication of the thread the message comes from.  Could add
	  time message was generated as well.

	* Added APICALL debug message type, and made many of the API calls
	  produce messages of this type.  Task for tomorrow is to make
	  all api calls produce such messages, and fully display their
	  parameters, and return values.

Wed Jun 28 20:14:54 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Make threadtest use a dlist file.

Wed Jun 28 17:58:50 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Make testsuite's memory checking threadsafe.

Wed Jun 28 16:24:49 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix deadlock in da_database.cc.

Wed Jun 28 15:23:07 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fixed configure so that --enable-debug=full actually _does_ select
	  verbose output.

Wed Jun 28 12:24:18 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* API addition - Add a OmEnquire::get_query() method, to retrieve the
	  query which was set.

Wed Jun 28 09:13:26 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add an OmLock, and sentries to the public methods in DADatabase.

	* Add "threadtest", a testsuite for checking thread safety.
	  Currently has no (completed) tests.

	* Compile various things only if network databases are compiled in.
	  (currently doesn't work correctly).

Wed Jun 28 03:58:42 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Don't compile network stuff if it's configured off.

Tue Jun 27 17:37:16 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added ability to get writable databases from database manager.

Tue Jun 27 11:19:01 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added test for requiring -nsl (eg, on solaris).
	  Only add network libraries if compiling in network code.
	  Change configure options for specifying debugging levels.

Tue Jun 27 10:09:13 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Changed "test -e" to "test -f" in Makefiles - test -e is not
	  portable.

Mon Jun 26 15:04:37 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added a swedish stemming algorithm.

Mon Jun 26 14:12:19 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Change debug class so that it has an operator<<, rather than
	  exposing a stream.  This is somewhat more portable.

Sat Jun 24 03:11:43 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Removed need for om_debug object to be initialised, since it wasn't
	  being on Solaris.

Fri Jun 23 18:56:13 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Removed use of a static object to do string to type conversion
	  (for stemming algorithm language specification, and for database
	  type specification).

Fri Jun 23 14:08:00 BST 2000 Olly Betts

	* Updated TODO

Thu Jun 22 15:01:00 BST 2000 Olly Betts

	* OM_DBTYPE_* now internal to database_manger.cc - use strings
	  elsewhere

	* Added "auto" database type which takes a directory and tries to
	  deduce what sort of database lives there

	* Moved file_exists() and files_exist() into utils.cc

Thu Jun 22 11:33:57 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* In Muscat36: throw exception if a keyfile is specified, but cannot
	  be opened.

Wed Jun 21 15:23:00 BST 2000 Olly Betts

	* apitest: if srcdir not set, sanity check our guess by seeing if
	  apitest.cc is there.

Wed Jun 21 15:35:58 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* In configure, actually try to link the test with the Dbt object
	  and db_cxx.h, to check that the library is properly installed.

Wed Jun 21 15:23:00 BST 2000 Olly Betts

	* Fixed bug in PhrasePostList; added regression test to apitest

	* Cleaned up PhrasePostList and NearPostList by eliminating PosList
	  and subclasses (added index member to PositionList instead)

Wed Jun 21 13:40:26 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add a --enable-quiet option to configure to turn off libtool
	  messages if they're not wanted.

	* Add a Dbt object to the test for db_cxx.h, to check that the
	  right library is being linked with.

	* Set datestamp in mkdoc.pl to consitent format with rest of
	  documentation.

Wed Jun 21 13:40:03 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Stoped the "undefined reference to SocketServer type_info node"
	  (or similar) linking errors with includetest.

Wed Jun 21 13:35:37 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* _Really_ stopped referring to OmSettings.

Tue Jun 20 18:27:55 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Stop compiling OmSettings in, at least for now.

Tue Jun 20 15:51:00 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a test for basic exception handling.

Tue Jun 20 14:53:28 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* The lex parser used for queries should no longer interfere
	  with other lexers.  (I was having problems in examples)

Tue Jun 20 14:49:54 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Portability fixes - network bits now stand a better chance
	  of compiling under Solaris.

Tue Jun 20 14:41:00 BST 2000 Olly Betts

	* PhrasePostList: added incomplete and disabled code for more
	  efficient implementation

	* added bindings/java/native/.cvsignore

Tue Jun 20 14:09:00 BST 2000 Olly Betts

	* apitest: TEST_EXPECTED_DOCS() changed to make use less verbose

Tue Jun 20 11:20:00 BST 2000 Olly Betts

	* apitest now tries to guess srcdir from argv[0] if it isn't in env

Tue Jun 20 10:31:00 BST 2000 Olly Betts

	* Removed NearOrPhrasePostList - code shared was negligible

Tue Jun 20 09:38:00 BST 2000 Olly Betts

	* Tweaked some FIXME comments

Mon Jun 19 18:26:50 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Some work towards getting the Java bindings into the make system.

Mon Jun 19 15:56:00 BST 2000 Olly Betts

	* Updated TODO

Mon Jun 19 15:46:00 BST 2000 Olly Betts

	* Tidied up near/phrase a bit

Mon Jun 19 14:48:00 BST 2000 Olly Betts

	* Fixed languages/porter/.cvsignore

Mon Jun 19 14:30:00 BST 2000 Olly Betts

	* Fixed various typos in ChangeLog and TODO

Mon Jun 19 14:09:00 BST 2000 Olly Betts

	* Improved near1 and phrase1 tests; fixed problems thrown up by more
	  demanding test cases.

Mon Jun 19 13:48:40 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* The Python interface now passes the OmBatchEnquire test.

Mon Jun 19 12:55:20 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added the Porter stemmer (without the recent improvements in the
	  current English stemmer)

Mon Jun 19 13:03:00 BST 2000 Olly Betts

	* SleepyPositionList now asserts !at_end() in get_position()

Fri Jun 16 18:11:03 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Now most of the way through getting a working OmBatchEnquire in
	  Python.

Fri Jun 16 15:43:00 BST 2000 Olly Betts

	* PHRASE now works; added test `phrase1' to apitest

Fri Jun 16 14:57:00 BST 2000 Olly Betts

	* Rearranged to create PhrasePostList (currently a clone of
	  NearPostList).  Shared code is in super classes.

	* `nearpostlist.*' renamed to `phrasepostlist.*'.

	* Fixed warning about declaration vs initialisation order in
	  OmQueryInternal

Fri Jun 16 12:49:00 BST 2000 Olly Betts

	* NEAR now works with distributed searching

Fri Jun 16 11:33:00 BST 2000 Olly Betts

	* NEAR now working; added NEAR test (near1) to apitest

	* OmQueryInternal copy constructor now copies max_weight

Thu Jun 15 18:43:29 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* OmLineBuf subclasses no longer need to implement wait_for_data()

Thu Jun 15 14:44:37 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* OmLineBuf now an abstract base class, with the functionality
	  moved to OmSocketLineBuf.

	* SocketServer can now take an OmLineBuf instead of a file
	  descriptor.

Thu Jun 15 13:33:00 BST 2000 Olly Betts

	* More work on NEAR/PHRASE

Thu Jun 15 12:16:00 BST 2000 Olly Betts

	* NEAR almost working - just need to do pushback of pos info

Wed Jun 14 18:26:00 BST 2000 Olly Betts

	* Added docs/todo.html to .cvsignore

Wed Jun 14 18:14:00 BST 2000 Olly Betts

	* PostListAndTermWeight scrapped; use get_maxweight() instead.
	  Fixes bug: max_or_terms now works with non-LeafPostlist-s;
	  regression test maxorterms2 added to apitest

	* Stub get_wdf() now in PostList

	* Documented PLPCmpLt and PLPCmpGt

	* More work on NEAR and PHRASE

Wed Jun 14 18:08:53 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Remove complicated class hierarchy for Stemming algorithms: replace
	  by OmStem::Internal, which has function pointers.  Necessitated
	  changing parameters taken by each stemming algorithm to a void *
	  instead of a specific struct pointer.

Wed Jun 14 18:07:43 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added test of OmStem::get_available_langs() to apitest: currently
	  disabled, since this is unimplemented.

Wed Jun 14 17:37:01 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* All classes except Om*Decider now added, although some are
	  incomplete.  OmBatchEnquire, OmDocumentContents, and
	  OmDocumentTerm need more work, but the rest should be
	  usable, at least from Python.

Wed Jun 14 17:02:06 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added docs/distributed.txt to the distribution tarfile. (Oops!)

Wed Jun 14 14:24:20 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added OmDatabase, OmWritableDatabase, and OmExpandOptions to
	  SWIG interface.

Wed Jun 14 12:14:42 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added OmDocument, OmRSet, OmESet, OmEnquire::get_eset(), and
	  OmEnquire::get_doc() to SWIG bindings, and implemented bits
	  needed for Python.

Tue Jun 13 18:04:43 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added OmEnquire::get_matching_terms() and OmMatchOptions to
	  SWIG bindings.

Tue Jun 13 17:37:00 BST 2000 Olly Betts

	* Added get_wdf() method to PostList

	* Tweaked MultiPostList::get_weight()

	* Added OM_MOP_PHRASE (not yet implemented)

Tue Jun 13 17:24:22 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added script to generate an HTML version of the TODO list.

Tue Jun 13 16:49:13 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* The scripting wrappers can now make queries with operations
	  other than OR and AND.

	* OM_MOP_NEAR added to the list of operations available.

Tue Jun 13 16:47:47 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Stopped includetest from importing the header files in bindings/java

Tue Jun 13 15:03:13 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add detection of SWIG to the configure script.  Don't attempt to
	  build SWIG stuff if swig isn't available.

Tue Jun 13 14:53:51 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* First cleanup of the java stuff.

Tue Jun 13 14:31:42 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add include path to common/Makefile.am.  Whoops.

Tue Jun 13 14:31:00 BST 2000 Olly Betts

	* Factored out code to build optimal AND and OR trees into separate
	  methods

Tue Jun 13 14:22:06 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added the java stuff to the bindings.  Needs some work to get it
	  nicely integrated.

Tue Jun 13 13:07:27 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Made multiexpand1 slightly more rigorous.

Tue Jun 13 12:44:01 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* API change: renamed OmExpandOptions::use_query_terms() to
	  OmExpandOptions::set_use_query_terms().  This is to be consistent
	  with OmMatchOptions' naming scheme.

	* API addition: added OmExpandOptions::use_exact_termfreq() to
	  allow disabling of termfreq approximation in ExpandWeight.

	* Update apitest to test API addition - enabled "multiexpand1": now
	  passes (but isn't as rigorous as I'd like).

Tue Jun 13 12:04:15 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Change ExpandWeight::get_bits() to take a document length, rather
	  than a normalised document length.  Normalise document lengths
	  across collection rather than across each sub-database.

	* Add an option to ExpandWeight to use the exact term frequency,
	  rather than approximate it.  (Currently set to false)

	* Fix formatting of output from testsuite.cc

Mon Jun 12 18:45:56 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix to omdebug.cc to get around a compiler brokenness.

Mon Jun 12 18:35:54 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added initial OmEnquire and OmDatabaseGroup stuff to
	  Python/Perl5 bindings.  Python works, but Perl5 crashes.

Mon Jun 12 18:22:00 BST 2000 Olly Betts

	* NEAR now works

Mon Jun 12 17:36:00 BST 2000 Olly Betts

	* get_position_list() now returns a pointer instead of a reference

	* More work on NEAR operator

Mon Jun 12 16:58:00 BST 2000 Olly Betts

	* Added NEAR operator (currently compiles but doesn't working)

Mon Jun 12 16:17:00 BST 2000 Olly Betts

	* Added skip_to() method to PositionList class

Mon Jun 12 15:37:45 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed an assertion in inmemory with no documents.

Mon Jun 12 14:04:00 BST 2000  Olly Betts

	* Added a NEWS file and removed "foreign" from Makefile.am-s

Mon Jun 12 13:00:00 BST 2000  Olly Betts

	* configure.in: Changed explicit use of echo to AC_MSG_xxx()

Mon Jun 12 12:32:00 BST 2000  Olly Betts

	* tests/stemtest.pl.in: Use -s instead of stat to find filesize
	(more readable)

Mon Jun 12 12:20:18 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Document the intended purpose of the debug message types, and
	  make the expand code emit typed debug messages.

Mon Jun 12 12:10:00 BST 2000  Olly Betts

	* Probe for -Wno-long-long with C compiler as well as C++ compiler

Fri Jun  9 17:51:16 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added lock() and unlock() methods to databases.

	* Added LOCK and API debug types.

	* Added new exception: OmDatabaseLockError.

	* Added type for timeout times: om_timeout.

Fri Jun  9 16:09:43 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Stemming interface working with tcl8, and guile (but with some
	  tweaks to the generated code.).

Thu Jun  8 18:59:55 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Initial guile bits.  (Not yet functional)

Thu Jun  8 16:28:07 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Perl5 and Python now both have more-or-less working OmQuery
	  interface.

	* Both interfaces can be built from the Makefiles (still more work
	  getting it working properly with automake and autoconf.

	* The "perl" directory has been renamed to "perl5".

Thu Jun  8 14:43:51 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Create an OmDebug object to manage debug messages.  This allows
	  the level of debug message to be selected and the output file for
	  debug messages to be set using OM_DEBUG_FILE and OM_DEBUG_TYPES
	  environment variables.

Thu Jun  8 11:32:11 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Removed some warnings from BackendManager.

Wed Jun  7 18:26:17 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix bug in Muscat3.6 backends causing an Assertion to fail when
	  the termfrequency of a term not in the database was requested
	  (should have returned 0).

Wed Jun  7 18:08:04 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* More work on scripting languages.  OmQuery _nearly_ works with
	  python.

Wed Jun  7 18:06:58 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Hopefully fixed a nasty refcount pointer bug.

Wed Jun  7 15:40:34 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Declare this to be version 0.2.0

Wed Jun  7 15:10:34 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Rename inttostring() to om_inttostring() to avoid conflicts.

Wed Jun  7 12:26:27 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Update licences.  Copyright is now held by BrightStation, which
	  is the new name for the part of what used to be Dialog which is
	  running this project.

Wed Jun  7 11:32:19 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Alter testsuite so that the nettests can work with sleepycat
	  databases if desired.

Tue Jun  6 19:10:26 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix nettest to use backend managers rather than inmemory's indexing.

Tue Jun  6 18:54:43 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Updated socketclient / socketserver to pass the collapse key
	  around with the mset items.

Tue Jun  6 18:34:36 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Update BackendManager to accept arbitrary numbers of database
	  parameters, and to cope properly if the datadir isn't specified
	  (ie, leave the filenames alone).

	* Turn off indexing code built into InMemory databases: they now need
	  to have their indexing done for them externally.

	* Add debugging code to net_document.cc

	* Make omprogsrv use a backend manager to perform its indexing.

Tue Jun  6 16:59:57 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Separate BackendManager from rest of code in apitest, and put it
	  into testsuite, ready for use in other tests.

Tue Jun  6 15:38:30 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Implemented a version of SleepyDatabase::do_get_all_keys().
	  Untested as yet.

Tue Jun  6 15:01:09 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added exception handling to scripting language bindings.

Tue Jun  6 13:11:15 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Stop using vectors of OmKeys, now use map<om_keyno, OmKey>
	  everywhere.

Tue Jun  6 13:08:58 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Beginnings of Perl5 bindings.

Tue Jun  6 12:57:54 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Implemented reading and writing of keys in sleepycat.  All tests
	  now pass on sleepycat: added this into the default testsuite run.

Tue Jun  6 11:59:39 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added a database to store keys in to sleepycat, and pass those keys
	  into document creation methods.  Now just need to write code to
	  read and write the keys.

Mon Jun  5 19:12:13 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix internaltest again (due to further change in sleepylists) and
	  turn off network tests in apitest, which accidentally got turned
	  on.

Mon Jun  5 18:59:49 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Moved implementation of OmExpand::get_bits() out of the header file.

	* Use actual normalised length in SleepyTermList for calculating
	  weight.  Now produces same result as InMemoryTermList.

	* Test that an expand across a multidatabase produces same result as
	  an equivalent expand across a single database.  This test fails,
	  because normalised lengths are not shared across databases.  This is
	  part and parcel of the need to restructure the way expand is
	  performed, which will take some time to accomplish, so the test
	  is disabled for now.

Mon Jun  5 18:54:14 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added proof-of-concept Python bindings for OmStem (using SWIG).

Mon Jun  5 17:41:14 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Make sleepylist optionally store termfreqency information in
	  list.  Make sleepy_termlists not store termfrequency information:
	  it will get looked up in the database instead.

Mon Jun  5 16:35:42 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added apitest for correct wdf values in termlists (indirectly,
	  by performing an expand on two different relevant documents of
	  the same length, and comparing the weights for a common term).
	  Fails for sleepycat, as expected.

Mon Jun  5 16:12:19 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Updated apitest's indexing to include keys, so the inmemory
	  tests now all work again.

Mon Jun  5 14:51:56 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* SleepyPostLists now use the document length when calculating weights.

Mon Jun  5 14:36:28 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix internaltest to cope with changed SleepyListItem parameters.

Mon Jun  5 14:31:50 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Inmemory database now supports "keys" properly.

Mon Jun  5 14:26:11 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Enable storage of the sum of the wdfs in a SleepyList in the list.
	  Use this to implement SleepyDatabase::get_doclength(), which reads
	  the wdfsum from the termlist.

Mon Jun  5 14:22:33 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Implement PostList::get_doclength() in each branchpostlist rather
	  than actually in the BranchPostList base class, since each
	  implementation needs to be different (both sub-postlists are
	  not always valid)

	* Use PostList::get_doclength() rather than the database version, to
	  get the document length in the matcher.

Sat Jun  3 00:31:19 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Attempt to make LocalMatch asks the query for the document length,
	  rather than the database.  This code currently commented out,
	  because it causes test failures and a segfault.

Sat Jun  3 00:18:50 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added a get_doclength() method to postlists.  Some return the
	  result of calling the get_doclength() method of the corresponding
	  database, branch ones return the result from one of the sub-branches,
	  and the sleepycat one returns the value stored in the postlist.
	  SleepyDatabase::get_doclength() is still unimplemented, however.

Sat Jun  3 00:01:55 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Improved configuration for finding c++ interface to sleepycat.  Now
	  works at home again...

Fri Jun  2 19:09:41 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Now stores document lengths in postlists.  Not yet accessible,
	  however.

Fri Jun  2 19:09:00 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Implemented NetworkDatabase::open_document().  Tests still fail
	  from some lack of support in other backends.

Fri Jun  2 18:22:03 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added get_all_keys() method to LeafDocument

	* Implemented in subclasses by throwing OmUnimplementedError.

Fri Jun  2 18:12:05 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Many fixes to sleepycat:

	  o Implemented document count and average document length
	    information.  (involves using a new "stats" database)

	  o Fix problem with calling get_termfreq for a term which doesn't
	    exist (used to throw: now returns 0)

	  o More useful debugging messages.  Better assertion checks.

Fri Jun  2 18:05:23 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Don't use terms with zero length names (ie, "") in the test
	  databases.

	* Add checks to API to complain about zero length termnames, and
	  assertions elsewhere in the code.

Fri Jun  2 18:00:25 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a text file explaining how to do distributed searches.

Fri Jun  2 13:27:01 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added a stats database to sleepycat, to store things such as
	  document count and length information.

Thu Jun  1 18:10:12 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Implemented max_or_terms.  Activated test in apitest to check that
	  it is working.

Thu Jun  1 16:40:03 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* ProgClient now reaps its child, so no more zombie buildup.

Thu Jun  1 15:33:29 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* TcpServer no longer inherits from SocketServer, but uses it.

	* omtcpsrv now handles more than one connection by default
	  (sequentially).

Wed May 31 16:05:06 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added support for default settings.

Tue May 30 17:52:43 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Stopped unnecessary options copying.

Tue May 30 17:49:56 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed #ifdef misplacement in internaltest.cc

Tue May 30 17:15:00 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* OmRefCntBase now has a (protected) copy constructor and a
	  ref_count_get() method.

	* OmSettings fixed.

Tue May 30 16:41:39 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Implemented OmSettings and added some tests (one still fails.)

Tue May 30 14:05:10 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* New class OmSettings for "global" options.  Not yet implemented
	  or used.

Fri May 26 11:58:24 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Hopefully better detection of Sleepy C++ bits.

Thu May 25 17:47:35 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added max_weight member to OmQueryInternal, so we can store the
	  termweight there when calculating elite terms.

Thu May 25 17:28:52 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Implemented Termlist fetching for net backend.

Thu May 25 15:23:11 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Attempt to build sleepycat support by default.  Also, try and make
	  it more obvious when something can't be found which is needed for
	  building requested support.

Thu May 25 15:22:10 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* More useful exception message when support for a particular
	  database type is not compiled in.

Thu May 25 14:33:20 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Socketserver now updated to use the modified MultiMatch
	  interface.

Thu May 25 14:21:07 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Made all MultiMatch::set_* methods private.  These are now called
	  from the constructor, based the arguments supplied to it.

	* MultiMatch now calls its submatchers prepare_match() at the end
	  of its constructor: this should fix the problems lately experienced
	  with network queries.

Thu May 25 12:07:29 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add a simple test of the max_or_terms feature to apitest.

Thu May 25 12:06:06 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add max_or_terms member to localmatch, to store option in.

Wed May 24 17:55:52 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Separated collection of statistics and building of the query
	  tree in LocalMatch.  Added method which will be used to select
	  terms for use in the query when max_or_terms is in effect.

Wed May 24 16:37:16 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Implemented get_doccount and get_avlength in NetworkDatabase.
	  Only 4 tests left failing with the net backend...

Wed May 24 12:50:19 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Exceptions are now propagated over the net link.

	* OmError's get_msg() method is now const.

Tue May 23 17:51:27 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add a LocalMatch::gather_query_statistics() method, to be called
	  before building the query tree, so that the tree can be pruned
	  based on the termweights of some of the probabilistic terms.

Tue May 23 17:34:30 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed max_attain for net backend.

Tue May 23 16:57:44 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Made RSets work with network db.

Tue May 23 16:36:25 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix bug due to uninitialised members in OmDocumentTerm.

Tue May 23 14:51:10 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed boolean queries with the net backend.

Tue May 23 14:06:40 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* apitest sleepy tests now remove the generated indexes before
	  running.

Tue May 23 12:18:31 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* SocketServer now correctly handles more than one query.

Tue May 23 12:00:38 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added a NetworkTermList object.  Currently a fair way from working
	  correctly, but it does compile:  uses lots of unimplemented
	  methods.

	* General work on termlists (documentation comments, code tidying),
	  and expand.

Mon May 22 18:36:43 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* ProgClient and omprogsrv can both now take more than one database
	  argument.

	* Net stuff now doesn't bomb out from SIGPIPE.

	* Miscellaneous bug fixes

	* apitest has code to run tests on the net backend.

Mon May 22 15:31:12 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Moved inline functions from testutils.h to testutils.cc

	* Separated out the non-backend-using tests from apitest to
	  avoid running them more than once when more than one backend
	  is compiled in.

Mon May 22 14:53:25 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* FAIL_TEST macro in testsuite.h now takes notice of the verbose
	  flag.

	* In theory, the sleepy tests are only run if the sleepy backend
	  is compiled in (as well as the #if 0)

Mon May 22 13:44:21 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Slightly improved summary reporting in apitest.

Mon May 22 13:28:26 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed a memory leak in SleepyDatabase (when database doesn't
	  exist).

Mon May 22 13:08:37 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* apitest can now run all the tests against sleepycat as well as
	  inmemory tables.  The actual call is currently protected by
	  #if 0.

Fri May 19 18:35:33 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Abstracted all database access in apitest to one function, so that
	  it can easily be made to run with different backends.

Fri May 19 16:30:53 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Changed raw uses of "cout" and "cerr" in net code to use
	  DebugMsg instead.

Fri May 19 15:58:11 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add test to nettest to try to do an expand.  Currently fails, since
	  this isn't implemented.

Fri May 19 11:48:15 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* MultiMatch::get_max_weight() now returns the maximum of the
	  max_weights from the submatchers, rather than just the first one.
	  This ensures that the correct value is returned in the case of
	  a multimatch with relevant documents in some of the submatchers.

	* Fix some test cases so that they test the correct things.

Fri May 19 11:43:09 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Further test to check that rset weights are getting distributed
	  correctly in multidatabase cases.

Thu May 18 18:11:16 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* MultiMatch now splits up RSets appropriately for each of its sub
	  databases, so multimatch stuff works correctly with RSets.

Thu May 18 17:14:52 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Work on testsuite.  Many useful macros produced, tests simplified,
	  and tests can now report failure by throwing an exception instead
	  of by returning "false".

Thu May 18 15:08:09 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added test for Rsets in a multimatch.  (Currently fails)

Thu May 18 12:11:50 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added support for using RSets with the network matches

	* Better timeouts when remote end unresponsive

Thu May 18 11:20:58 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added test that setting an rset has appropriate effect on match
	  results (relevant document comes to top).

Thu May 18 11:15:36 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added new exception OmInternalError for really weird problems.

Wed May 17 18:12:53 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added simple test for RSet usage.

Wed May 17 17:52:22 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix memory leak in rset.cc

Wed May 17 17:26:41 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* BM25Weight and TradWeight now ask their statssource for information
	  about the RSet, rather than asking the rset directly.  As a result,
	  they no longer have or need an "RSet * rset" member.

Wed May 17 17:09:35 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* RSet now has a give_stats_to_statssource() method, used by
	  localmatch to pass the statistics to the stats system for
	  sharing and merging.

Wed May 17 15:56:52 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Pass relevance sets around as OmRSets, only creating an RSet within
	  LocalMatch.  RSet now has a method to tell it to calculate the
	  statistics, which is called after the query has been constructed,
	  paving the way for integration with StatsSources.

Wed May 17 15:56:36 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Ensure that the a refcount pointer is not made from a standard pointer
	  more than once.

Tue May 16 16:29:25 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* apitest now performs its own indexing for tests.  Next step is to
	  stop nettest using the internal indexing in InMemoryDatabase and
	  then stop InMemoryDatabase accepting path parameters.

Tue May 16 15:07:46 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added add_database() method to OmDatabaseGroup which takes an
	  OmDatabase object, instead of parameters for opening a database.

Tue May 16 12:48:40 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Assignment operators for OmDatabase and OmWritableDatabase are
	  now safe: assignment of a OmDatabase to an OmWritableDatabase
	  will either fail to compile or throw an exception, all other
	  possibilities will work.

Tue May 16 12:22:33 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Now pass match options over the net link.  (Untested so far)

Tue May 16 12:06:23 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Created an OmDatabase object.  This represents a database,
	  and is a base class for OmWritableDatabase, which is a database
	  which can be written to.  Implemented, except for assignment
	  operators which may operate incorrectly.

Mon May 15 13:34:39 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Moved OmDatabaseGroup into a separate header file.

Mon May 15 12:23:16 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Bugfix: MultiDatabases term existence cache no longer grows
	  arbitrarily.  (But not an efficient implementation)

	* SingleMatch now inherits from OmRefCntBase, so we can use
	  reference counted pointers to it.

	* More work tidying up structure of MultiDatabase and MultiMatch.

Mon May 15 11:34:16 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Now use SO_REUSEADDR in TCP server

	* Added the first tcp test to nettest.

Fri May 12 19:18:43 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Bug fixes to the TCP server

Fri May 12 18:48:14 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Make OmDatabaseGroup now stores opened databases, rather than
	  their parameters.

	* OmDatabaseGroup::InternalInterface now uses a method in
	  OmDatabaseGroup::Internal to get_multidatabase.  Same MultiDatabase
	  is returned after each call, unless a database has been added.
	  Pthread locking is also sorted out.

Fri May 12 18:29:01 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* New class OmDatabaseGroup::InternalInterface, used to extend
	  the OmDatabaseGroup interface for internal use.

	* ProgServer's implementation mostly moved into new SocketServer.

	* New class TcpServer deriving from SocketServer

Fri May 12 16:10:44 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Remove set_root() method and "root" member from IRDatabase, and
	  subclasses.  This is now catered for by stats and weighting
	  objects.

Thu May 11 18:51:22 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add constructor to MultiDatabase, taking a vector of IRDatabase
	  pointers.

	* Store subdatabases in MultiDatabase in a vector of reference
	  counted pointers, rather than as pointers.  This has no actual
	  effect yet, but will do when we extend the use of these pointers
	  to the rest of the code (currently we pass them out as standard
	  pointers)

Thu May 11 17:05:11 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add rule so that internaltest will compile with special CFLAGS,
	  to ignore access control.

Thu May 11 16:40:30 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Make OmRefCntBase::ref_count mutable, and ref_increment() and
	  ref_decrement() into const methods, so that we can have reference
	  counted access to const objects.

	* Make DATerm and DBTerm objects reference counted, and store
	  reference count pointers to them in the term cache.  This results
	  in removing the possibility of open_post_list() having the Term
	  object it is dealing with deleted from underneath it due to
	  concurrent access.

Thu May 11 16:38:05 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Made the internals of OmRefCntBase private, and moved
	  increment() and decrement() from OmRefCntPtr to OmRefCntBase,
	  where they belong.

	* Made OmRefCntPtr::operator *() return a reference as it should,
	  rather than a pointer as it did previously.

Wed May 10 17:34:16 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added (untested) TcpClient class.

Wed May 10 15:26:37 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Split all the generic socket stuff from ProgClient into a
	  SocketClient base class.

Tue May  9 17:30:46 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added collapse code to MultiMatch.  Could be considerably more
	  efficient, but appears to work correctly.

Tue May  9 16:37:04 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Refactored mset merging code in MultiMatch::match() into separate
	  methods.  Now ready to add collapse code.

Tue May  9 16:16:06 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Network stuff should now time out if there is no response.

Tue May  9 14:45:44 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* OmMSetItems now have a collapse_key member, which the key used
	  for removal of duplicates is stored in.  This allows MultiMatch
	  to see these keys, and thus to remove duplicates across several
	  matchers, and also lets the user see the keys used.

Tue May  9 13:12:58 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* New exception: OmNetworkTimeoutError.

Tue May  9 12:21:35 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* MultiMatch::match() now returns all its results in its OmMSet
	  parameter, which is thus now fully set by this method.

Tue May  9 11:52:05 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* MultiMatch::match() takes an OmMSet instead of a vector<OmMSetItem>.
	  Next step is to make all the elements of the MSet get set correctly,
	  not just the items.

Mon May  8 19:42:48 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Stop MultiMatch going into a tight loop when waiting for sub
	  matchers to prepare_match() or get_mset(), by doing one pass of
	  non blocking IO, and then blocking IO for subsequent calls.

	* Refactor MultiMatch::match() into more separate methods.

Mon May  8 19:14:19 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* In MultiMatch::match(), factor out adding of a new mset to
	  a separate method, add_next_sub_mset().

Mon May  8 16:42:24 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Moved specification of mset comparison method into Match Options.
	  Renamed the comparator class OmMSetCmp (from MSetCmp), and created
	  a method in OmMatchOptions to return an appropriate instance.
	  Made comparator a member of LocalMatch and MultiMatch, which gets
	  set by the set_options() method.

Mon May  8 16:33:16 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Moved testsuite module to a new directory.  Tests within the
	  other source directories should be able to link to it easily.

Mon May  8 14:34:21 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Moved mostly common implementation of test suite main() functions
	  into test_driver::main().

Fri May  5 18:55:31 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Pass MatchOptions object down to LocalMatch, rather than
	  interpreting at API level.

Fri May  5 16:55:57 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add option to MatchOptions to set a maximum number of terms to
	  OR together in large probabilistic queries.

Thu May  4 16:58:08 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* ProgClient::get_mset() now returns actual results rather than
	  accidentally made up numbers.

Thu May  4 16:26:34 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* The testsuite driver now supports running a single test by name.

	* apitest and internaltest now support an extra argument which
	  specifies the name of a single test to run.

Tue May  2 18:56:20 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* get_mset() now actually asynchronous.

Tue May  2 18:22:31 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* The framework for making get_mset() asynch is there.

Tue May  2 16:21:57 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* prepare_match() is now actually asynchronous

Tue May  2 14:35:01 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Changed signature of Match::prepare_match() to allow for
	  asynchronous processing.

Fri Apr 28 18:55:12 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Begun process of making OmDatabaseGroup use reference counted
	  databases, rather than just the parameters, so that we can add
	  opened database objects to a database group.

Fri Apr 28 17:51:06 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added configure checking for getopt.h

Fri Apr 28 17:17:23 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Add insure and purify configure options.

Fri Apr 28 16:22:56 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added checking for -lsocket on Solaris

Fri Apr 28 10:27:06 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* ProgServer exits when it receives "QUIT"

	* ProgClient sends "QUIT" before exiting.

Thu Apr 20 18:00:36 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* StatsSource now has two variants - LocalStatsSource and
	  NetworkStatsSource

	* Some changes to the prototype protocol

	* ProgClient and ProgServer use OmLineBuf to share code

	* Some code moved around

Thu Apr 20 17:52:49 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* New OmLineBuf object to handle line buffering over a connection

Thu Apr 20 15:38:39 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Declare this to be version 0.1.3

Thu Apr 20 14:37:14 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fixed main part of bug with MSet docid merging in MultiMatch.
	  Will still fail to do collapse operation across multiple databases.

Thu Apr 20 13:20:33 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed some memory leaks.

Thu Apr 20 13:06:49 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added a test for multimatch's document ID merging to apitest

Thu Apr 20 12:53:12 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added some memory leak checking in the test suite driver.

Thu Apr 20 12:06:18 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Stopped SleepyDatabase aborting nastily when an attempt to
	  open in a non existent directory is performed.

Wed Apr 19 18:45:21 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* parameter checks when opening databases now throw
	  OmInvalidArgumentError exceptions, rather than just being Asserts.

Wed Apr 19 18:10:31 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Changed PostList::get_position_list() to be non-const, since it
	  modifies the PostList in many implementations.

	* Implemented SleepyPositionList.

Wed Apr 19 16:47:49 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added a PositionList base class, and methods to return position
	  lists from postlists.  No actual PositionLists yet implemented.

	* Fixed a resource (memory and file descriptor) leak in Muscat36
	  backends.

Tue Apr 18 16:42:03 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Made OmDocumentContents contain OmDatas and OmKeys rather than
	  strings.  Added constructors to OmData and OmKey.

Tue Apr 18 15:43:30 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* StatsGatherer now knows about its associated StatsSource objects.

	* StatsGatherer is now responsible for calling
	  StatsSource::contrib_my_stats() on all its children, instead
	  of LocalMatch::prepare_match().

Mon Apr 17 17:48:48 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Implemented sleepycat termlists.

Fri Apr 14 17:22:04 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added quickstart guide to documentation.

	* Declare this to be Version 0.1.2

Thu Apr 13 11:05:31 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Document data storage implementation done.  Sleepydatabase now
	  functions for simple retrieval: missing is general database
	  statistics (eg, get_doccount() always returns 1), and storage of
	  keys.

Thu Apr 13 01:37:41 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added SleepyDocument class, to store keys and document data.
	  Implementation not yet done.

Wed Apr 12 19:31:21 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* API change - added a termfreq member to OmDocumentTerm.

	* SleepyDatabase now adds entries to postlists and termlists.  Doesn't
	  yet store documents, or correct already existing wdfs in termlists.

Wed Apr 12 17:36:58 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added internal test to check that SleepyList packs and unpacks
	  correctly.

Wed Apr 12 16:22:39 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* libomus-config now gives flags required to link with dependent
	  libraries (as determined by libtool).

Wed Apr 12 15:50:41 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* add_document methods now all return a om_docid value (rather than
	  void)

Wed Apr 12 15:49:17 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* MultiMatch now takes an optional StatsGatherer argument to
	  its constructor.

Wed Apr 12 14:03:52 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* IRDatabase now inherits from OmRefCntBase: we have multiple
	  inheritance!  This means that we can now have reference counted
	  access to databases from the API.

	* OmWritableDatabase is now implemented in the API, opens the
	  database, and is well defined.  add_document() is the only method
	  not yet implemented, and simply throws an exception.

	* simpleindex example now compiles, links, runs, and reports an
	  exception.

Wed Apr 12 13:22:26 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Sorted out the mutex situation with Om/LeafDocument.

Tue Apr 11 22:01:03 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Renamed DocumentContents and DocumentTerm to OmDocumentContents and
	  OmDocumentTerm, and added these classes to the API.  Moved these
	  from "common/document_contents.h" to "include/om/omindexdoc.h"

	* Added a OmWritableDatabase class to the API.  Implemented some of
	  the needed methods.

Tue Apr 11 21:14:18 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* SleepyDatabase now knows how to allocate a new term ID for a new
	  term, and does some of the needed actions to add a new document to
	  the database.

Tue Apr 11 19:18:34 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Backwards incompatible API CHANGE:
	  OmDatabase renamed to OmDatabaseGroup, since this is what it is,
	  and better to change it sooner than later.
	  No work other than renaming the class should be necessary to fix
	  old code.

Tue Apr 11 18:05:51 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Rework of indexer classes.  The indexer destination interface now
	  has only one method, which is add_document.  This gets passed
	  a DocumentContents, so the whole document is added to the database
	  at once.  Works for all backend types except sleepycat.  (Although
	  all except InMemory throw an OmUnimplemented exception.)

Tue Apr 11 13:59:24 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* More detection stuff for sleepycat library: now works on all my
	  machines, but isn't really generic enough yet.

	* SleepyList now has methods to iterate through the list.

Thu Apr  6 00:57:46 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* More sleepycat stuff:
	  o) Generic list implementation now allows items to be added, lists
	     to be written to databases, and lists to be read back from
	     databases.  Doesn't yet allow iteration through lists.
	  o) PostLists can be opened using the list implementation, and sizes
	     returned, but all other functionality not there yet.

	* Modifications to the configure system: now picks up sleepycat stuff
	  on my home machine.

Tue Apr  4 18:49:15 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Generic list implementation for sleepycat is now almost complete
	  (doesn't yet write lists, but all the other code is there).  Fully
	  untested, obviously.

Tue Apr  4 14:49:09 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* A really hacked network multimatch gets the same results as
	  the multidb1 test in apitest.  Much cleanup needed.

Mon Apr  3 17:55:04 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Removed open() method from IRDatabase().  Use constructor to open
	  database instead: this is _much_ cleaner.

Fri Mar 31 19:00:50 BST 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* First remote mset retrieved.  Still doesn't complete the whole
	  match process, but getting there.

Wed Mar 29 18:01:46 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Split sleepycat database stuff into separate files, and made it
	  compile on a debian system.  (Needs autoconf detection of sleepycat
	  db.)

Tue Mar 28 18:43:16 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Lots of documentation comments in database.h

	* Changed signature of IRDatabase::open_post_list() so that it
	  doesn't take an rset:  was never used (weight is told directly
	  instead.)

Tue Mar 28 14:07:21 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix for a bug with setting query from vector.

	* Added test case for the bug.

Tue Mar 28 11:17:23 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Now builds query tree when prepare_match() is called, so correct
	  stats get shared again.

Mon Mar 27 18:36:06 BST 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Renamed SingleMatch::match() to SingleMatch::get_mset()

	* Added SingleMatch::prepare_match() to be called before get_mset()
	  or get_max_weight(), which flushes the statistics with the
	  StatsGatherer.

Fri Mar 24 17:56:41 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a NetClient interface for remote matchers

	* Implemented ProgClient as a convenient test implementation

	* Added an OmNetworkError exception class

	* Documentation doesn't get built by default

Fri Mar 24 17:39:37 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added OmDocumentParams class, to provide opaque but clean way
	  to give parameters to OmDocument constructor.

	* Cleaned up various OmLock mutexes; made them private and made the
	  classes lock them when public methods are called, rather than
	  expecting the calling class to lock them.

	* Now follow policy of not calling public methods from within
	  same class.

	* Added many documentation comments, mainly to API code, but also
	  generally.

Fri Mar 24 13:41:17 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added net/ directory with (very) start of remote match code.

Thu Mar 23 15:00:54 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* MultiMatch now takes care of its own StatsGatherer

	* MultiMatch now owns the RSet and SingleMatch objects given
	  to it, and will delete them.

Thu Mar 23 12:49:03 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Changed OmKey to use a string rather than an integer for the
	  key value.

	* Added ability for DA and DB databases to read keys from a fast
	  access separate keyfile, falling back to reading from the record
	  if the keyfile isn't present, or doesn't contain enough keys.

	* Changed parameters for DA and DB database slightly.  Change is
	  backwards compatible.

Wed Mar 22 18:39:03 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added configure option to turn on profiling.

Tue Mar 21 15:41:49 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Tidy up structure of LeafMatch a great deal.

	* Fix bug causing a segfault when a term which doesn't exist comprises
	  the entire query.

Tue Mar 21 15:26:03 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Test behaviour when searching for terms not in database.

Tue Mar 21 15:08:11 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Implemented OmQueryInternal::operator=()

Tue Mar 21 11:42:39 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fixes to m4 macro.  Now works correctly in both installed and
	  uninstalled cases.

Mon Mar 20 13:02:37 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Removed old Match::boolmatch() methods - superseded.

Mon Mar 20 12:50:40 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Made OmEnquire use reversebool when specified in moptions.
	  All tests now pass!

Mon Mar 20 12:23:03 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Made OmEnquire use BoolWeight to get result for boolean queries.
	  Doesn't yet pass correctness tests.

Mon Mar 20 12:21:19 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added an internaltest test for the refcounted pointers

Fri Mar 17 18:55:40 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added BoolWeight object, returns zero for all methods, for pure
	  boolean queries.

Fri Mar 17 18:38:18 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added set_weighting() method to match, to set weighting scheme
	  to be used (as a value from the IRWeight::weight_type enum).
	  Updated OmEnquire to use this: ability to set weight is just
	  one little step away from the API and the user now.

Fri Mar 17 13:39:10 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Declare this to be version 0.1.1

Thu Mar 16 17:33:36 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* New program "internaltest" added to the test suite, for
	  testing code behind the API.

	* Can now disable pthread support via configure

Thu Mar 16 13:01:46 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fixes for uninitialised memory problems.  (malloc was being
	  assumed to zero the returned memory.)

Thu Mar 16 12:49:44 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* New OmDocument which is copyable, and is actually a wrapper
	  around LeafDocument.

	* Added reference-counted smart pointer, used in above.

Wed Mar 15 18:27:10 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Now uses a MultiMatch object to do match.  Doesn't yet use more
	  than one LeafMatch for this object though.

Tue Mar 14 18:46:17 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Match now has the appropriate virtual methods, which are
	  implemented by LeafMatch, and will be implemented by MultiMatch.
	  Some work in OmEnquire, so that I can test this.

Tue Mar 14 13:33:43 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Make sure we don't have -g in compile line if debugging is off.

Thu Mar  9 17:12:16 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Declare this to be version 0.1.0

Thu Mar  9 17:48:02 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fix many spurious debugging messages

Thu Mar  9 17:03:35 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added test for OmBatchEnquire (and fixed a bug in it)

Thu Mar  9 16:00:18 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Don't use -O6 when debugging is turned on.  Debug compiles
	  are much faster now.

Thu Mar  9 15:46:17 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Stemtest.pl now cleans up after itself a bit better.

Thu Mar  9 15:17:47 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Use Stats objects to pass statistics needed for the match around,
	  instead of directly asking the database.

	* Change parameters for BM25Weight: attach less importance to
	  document length.

	* Now copes with empty sub-databases rather better.

	* Calculate max_possible_weight (and thus percentages) correctly
	  when using BM25Weight.  (Had forgotten additive parameter.)

	* More debugging messages available.

Thu Mar  9 11:20:55 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Removed inline from omenquireinternal methods.

Wed Mar  8 18:24:27 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added OmBatchEnquire for batch queries.

Tue Mar  7 18:09:36 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added configure option to use error-checking mutexes instead
	  of the (portable) default.

Tue Mar  7 12:20:08 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Sleepycat backend now compiles, although undoubtedly isn't
	  going to work properly.

Tue Mar  7 12:17:47 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added OmRangeError and OmDatabaseError exceptions.

Mon Mar  6 18:05:17 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* stemtest.pl now handles the child getting a Ctrl-C nicely.

Fri Mar  3 15:25:42 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added to one of the tests in apitest a check that the weights
	  returned by a query are as expected.  This will fail if weighting
	  schemes are changed, deliberately or accidentally.

Fri Mar  3 11:25:36 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* OmQuery now does a better job of collapsing sub-queries
	  with the same operator.  Yet another test now passes.

Thu Mar  2 17:47:29 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Moved omenquire and omstem into new directory api

	* Split omenquire.cc into omenquire, omquery, and omdatabase

Thu Mar  2 14:53:47 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Removed all mentions of virtual inheritance.

Thu Mar  2 10:58:19 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Begun to abstract statistics requesting and collecting operations
	  (common/stats.h)

	* Made hierarchy of Match objects: Match, LeafMatch, MultiMatch.

Thu Mar  2 10:39:20 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added locks to OmDatabase methods

Wed Mar  1 19:14:02 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Separated OmDatabase out from OmEnquire, and fixed the tests.

Tue Feb 29 17:41:32 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Change OmMatch to LeafMatch.  Make LeafMatch inherit from Match,
	  which is currently an empty class, but will be a base class for
	  all match objects.

Tue Feb 29 10:49:54 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed apitest following the stemming changes

	* Fixed a bug which broke query length calculation

Mon Feb 28 17:26:01 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a test for the query collapsing, along with a fix.

Mon Feb 28 16:32:22 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Queries now combine identical terms into a single term
	  with the sum of the wqfs in some cases.

Mon Feb 28 13:09:18 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Query lengths are now automatically calculated

	* Some tests of the query length calculation are now in apitest

Fri Feb 25 16:38:46 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a test for -Wno-long-long in configure.in

Fri Feb 25 14:29:00 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Separated most of OmQuery into an OmQueryInternal class.

	* Locks in the OmQuery methods

Thu Feb 24 20:10:28 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added test for behaviour when trying to use a file which doesn't
	  exist.

Thu Feb 24 16:12:16 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Changed DBPostlist to LeafPostlist.

	* Added DBDatabase and related classes, for reading DB format (old
	  muscat) databases.

Thu Feb 24 14:36:45 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added locking to OmStem

Thu Feb 24 14:18:29 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Cleaned up the public/private separation in OmEnquire{Internal}

	* Added exclusive locks to all public methods

Wed Feb 23 19:00:10 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added initial pthread locking support.  More does need to be
	  done.

Wed Feb 23 17:33:43 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a test "includetest" which simply checks that a program
	  which includes all headers in the project compiles.

Wed Feb 23 14:46:16 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Muscat36 backend now replaces DA backend.
	  Should be able to cope with both flimsy and heavy duty DA files.
	  DB stuff will be added shortly.

Wed Feb 23 14:44:58 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added (mostly private unimplemented) copy-constructors and
	  assignment operators to several classes.  Also added some
	  virtual destructors where needed.

Mon Feb 21 18:07:14 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Attempts to build a query with a boolean subquery throws an
	  exception for now.

Mon Feb 21 15:33:10 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added test for OmEnquire::get_matching_terms()

	* Fixed OmEnquire::get_matching_terms

Mon Feb 21 14:38:30 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Made OmQuery::get_terms() public, tightened the specification,
	  and made it conform to the specification.

	* Added a test for the above to apitest

	* Fixed a bug in OmQuery::initialise_from_copy() to make the above
	  test work.

Fri Feb 18 18:06:21 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Databases now have a get_doclength() method, to return the length
	  of a given document.  There may be efficiency issues with using
	  this during the search, however.

	* Extra constant terms, such as that in BM25Weight, now used
	  and accounted for in min weight calculations.

Fri Feb 18 17:49:13 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* OmQuery::get_terms now returns the terms in termpos order.

Fri Feb 18 13:53:34 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added second test for reversed boolean queries.
	  (When the full mset is not returned.)

Fri Feb 18 13:54:37 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Implemented match functors

	* IRDocument is now OmDocument, on <om/omdocument.h>

Fri Feb 18 13:53:34 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added test for reversed boolean queries.

Thu Feb 17 18:13:24 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a test for collapsing on a key

Thu Feb 17 16:57:42 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added interface to stemming algorithms to API (OmStem class)

Thu Feb 17 12:00:33 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Header files now get installed in a subdirectory (om/)

Tue Feb 15 17:03:31 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Implemented the "allow query terms" option for Expand Terms.

	* Added some useful ExpandDeciders to omenquire.h

Tue Feb 15 12:59:43 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* The dvi documentation is now automatically built and added
	  to the distribution.

Mon Feb 14 17:23:38 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Implemented OmQuery::get_terms()

	* Implemented OmEnquire::get_matching_terms()

Mon Feb 14 13:37:56 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added tests for OmExpandOptions and OmMSet.max_attained

Fri Feb 11 18:40:39 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed the percent cutoff test in apitest.

Fri Feb 11 17:52:42 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added percent cutoff to the API, and added a test to apitest
	  for it.

Fri Feb 11 16:44:34 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* The api docs now go into the distribution tarball.

Thu Feb 10 18:53:33 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added OmEnquire::get_matching_terms() to the API.

Thu Feb 10 18:02:37 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added tests to apitest for the match and expand decision functors,
	  and added another shorthand function to reduce code duplication.

Thu Feb 10 16:04:45 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* More documentation in omenquire.h

	* Changed isnull to isdefined (note change of sense), since this makes
	  more sense, and is hopefully less likely to confuse.

Thu Feb 10 14:17:31 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Lots more documentation comments in omerror.h and omenquire.h

	* Added API calls to set decision functors for matcher - not yet
	  implemented, however.

Wed Feb  9 17:11:13 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Implemented far enough for it to compile.
	  (Doesn't calculate query length automatically)

Wed Feb  9 16:45:19 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added calls to specify within query frequency, positional
	  information, and query length.  Not yet implemented.  (So, won't
	  compile.)

	* Can set boolean flag on a query directly.

	* Many documentation comments added to header files in include/

Wed Feb  9 16:42:08 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* stemtest.pl handling of random input data improved:

	  o doesn't bother regenerating the random data every time.

	  o the seed is actually generated from the hostname, rather
	    than being hard-coded to 1.

	  o support for running the test with a specified seed

	  o some basic tests that the output is sensible

Wed Feb  9 14:52:54 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Rename all exception classes to have names ending in Error

Wed Feb  9 14:48:48 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added and implemented get_doc_data in OmEnquire

	* Now get msets and esets by return value rather than reference
	  argument.

Wed Feb  9 11:18:48 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Fixed the header guards (now all caps, should be unique, and don't
	  start with underscores).

Tue Feb  8 20:04:34 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Changed prefix OM to Om in all class names.

Tue Feb  8 19:17:53 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Changed OMMSet::max_weight to OMMSet::max_possible.
	  Added OMMSet::max_attained, which is weight of top match, (not
	  necessarily top item in MSet)

	* Allow user to specify decision function for expand.

	* Also allow user to specify that query terms should not be returned
	  by expand, by calling OMExpandOptions::use_query_terms().                       This does not yet work, however.

	* Add many code comments, and make doc++ stuff work better.

Tue Feb  8 19:13:43 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added some more tests.

Tue Feb  8 16:51:22 GMT 2000 Richard Boulton <richard.boulton@open.muscat.com>

	* Fixed boolean only querying.

	  o) Made isbool get set correctly (was being unset by
	    initialise_from_copy)

	  o) Set max_weight correctly.

Tue Feb  8 16:28:48 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added the stemmer test script, stemtest.pl

Mon Feb  7 19:17:25 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Prefix all the types in omtypes.h with "om_".

Mon Feb  7 17:37:52 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Added a test of boolean-only queries to apitest, which fails.

Mon Feb  7 15:56:43 GMT 2000 Chris Emerson <chris.emerson@open.muscat.com>

	* Improved exception hierarchy:

	  o Exceptions are all split between `OmLogicError' and
	    `OmRuntimeError'.

	  o Plain `OmError' exceptions are no longer allowed.

	  o All exception classes are prefixed with `Om'.

Mon Feb  7 12:57:12 GMT 2000 Richard Boulton <richard.boulton@open.muscat.com>

	* Make get_eset()'s max_items parameter work.
	  (Changed max_esize in OMExpand from a member to a parameter of
	  expand() )

	* Implemented add_database() correctly in OMEnquire: can now do
	  multi database stuff.

Mon Feb  7 12:53:33 GMT 2000  Chris Emerson <chris.emerson@open.muscat.com>

	* Added tests to apitest for maxitems parameters and null queries

Mon Jan 31 17:00:18 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* OMMatch stores query in a pointer rather than the historical
	  remnants of a stack.
	  OMEnquire updated accordingly.

	* OMEnquire deallocates RSet correctly.

	* querygui example compiles and works.

Fri Jan 28 16:44:49 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Fixed problems with assigning to a query (old query elements were
	  left in place.)  Implemented automatic merging of OR and AND nodes
	  into a single list of terms to be ORed or ANDed.

Fri Jan 28 15:53:53 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Added introspection methods to OMQuery.

Fri Jan 28 13:41:20 GMT 2000  Richard Boulton <richard.boulton@open.muscat.com>

	* Started ChangeLog

	* Previous state of code:

	  o An API for searching has just been created, but is undocumented,
	    will change in various ways in the coming weeks, and isn't quite
	    implemented correctly when building queries containing more than
	    one term.

	  o Stemming algorithms for dutch, english, french, german, italian,
	    portuguese and spanish added and tested.

	  o Searching through DA databases, raw text files (with naive
	    indexer) and multiple databases implemented.

	  o Documentation in a reasonably sorry state.  Next week is
	    documentation week.
